***************************************************
* Creates the correct type for each variable
* and also creates labels for categorical variables
***************************************************
destring numrecalledtask, generate(recalled_tsk)
destring numfamiliestask, generate(families_tsk)
destring numlargesttask, generate(largest_tsk)
destring numsmallesttask, generate(smallest_tsk)
destring numrepeatedtask, generate(repeated_tsk)
destring numrelatedtask, generate(related_tsk)

destring numrecalledall, generate(recalled_all)
destring numfamiliesall, generate(families_all)
destring numlargestall, generate(largest_all)
destring numsmallestall, generate(smallest_all)
destring numrepeatedall, generate(repeated_all)
destring numrelatedall, generate(related_all)

*! Recode percentagecovered as numerical and then specify the codebook
replace percentcovered = "-1" if percentcovered == ""
replace percentcovered = "0" if percentcovered == "0-24"
replace percentcovered = "1" if percentcovered == "25-49"
replace percentcovered = "2" if percentcovered == "50-74"
replace percentcovered = "3" if percentcovered == "75-100"
rename percentcovered tmp
destring tmp, generate(percentcovered)
drop tmp
label define percent 0 "0-24" 1 "25-49" 2 "50-74" 3 "75-100"
label values percentcovered percent

drop num*
*! Recognize the missing values
mvdecode *, mv(-1)
preserve