***************************************************
* Labels variables for data from questionnaire
* Deletes unnecessary variables
* Creates codebook for variables
***************************************************

*! Remove unnecessary variables
drop q0 q1 q3-q6

*! Fixup people who've put in their userids instead of their participant id
rename q7 uid
replace uid = "7555" if uid == "xxx"
destring uid, replace

*! Codebook labels
label define yes_no 0 "No" 1 "Yes"
label define ago 0 "<= 19" 1 "20-24" 2 "25-34" 3 "35-44" 4 "45-59" 5 ">= 60"
label define agreement 1 "Strongly Disagree" 2 "Slightly Disagree" 3 "Neither Agree nor Disagree" 4 "Slightly Agree" 5 "Strongly Agree" 0 "Refrain from Answering"
label define attackers 1 "Friend" 2 "Acqaintence - Non-Tech" 3 "Acquaintence - Computer Expert" 4 "Insider" 5 "Competitor" 6 "Unaffiliated"
label define existence 0 "Negative" 1 "Positive"

* Describe refused to select for attacker scenario
destring q60, replace force
destring q61, replace force
destring q62, replace force
destring q63, replace force
destring q64, replace force
destring q65, replace force
destring q67, replace force
destring q68, replace force
destring q69, replace force
destring q70, replace force
destring q71, replace force
destring q72, replace force
destring q74, replace force
destring q75, replace force
destring q76, replace force
destring q77, replace force
destring q78, replace force
destring q79, replace force

* Convert variables into ints
* q8              str3   %9s                    Are you a student?
* q11             str6   %9s                    Gender
* q12             str3   %9s                    Age
* q13             byte   %8.0g                  Computer Experience
* q108            str37  %37s                   last time created a new password
* First copy ones we'd want to keep answers for
generate otherCurrentTools = q89
generate otherPastTools = q89
generate otherStoreInfo = q107
* Now convert
replace  q81 = "1" if q81 != "-1"
replace  q82 = "1" if q82 != "-1"
replace  q83 = "1" if q83 != "-1"
replace  q84 = "1" if q84 != "-1"
replace  q85 = "1" if q85 != "-1"
replace  q86 = "1" if q86 != "-1"
replace  q87 = "1" if q87 != "-1"
replace  q88 = "1" if q88 != "-1"
replace  q89 = "1" if q89 != "-1"
replace  q90 = "1" if q90 != "-1"
replace  q91 = "1" if q91 != "-1"
replace  q92 = "1" if q92 != "-1"
replace  q93 = "1" if q93 != "-1"
replace  q94 = "1" if q94 != "-1"
replace  q95 = "1" if q95 != "-1"
replace  q96 = "1" if q96 != "-1"
replace  q97 = "1" if q97 != "-1"
replace  q98 = "1" if q98 != "-1"
replace  q99 = "1" if q99 != "-1"
replace  q100 = "1" if q100 != "-1" 
replace  q101 = "1" if q101 != "-1" 
replace  q102 = "1" if q102 != "-1" 
replace  q103 = "1" if q103 != "-1"
replace  q104 = "1" if q104 != "-1"
replace  q105 = "1" if q105 != "-1"
replace  q106 = "1" if q106 != "-1"
replace  q107 = "1" if q107 != "-1"

destring  q81, replace
destring  q82, replace
destring  q83, replace
destring  q84, replace
destring  q85, replace
destring  q86, replace
destring  q87, replace
destring  q88, replace
destring  q89, replace
destring  q90, replace
destring  q91, replace
destring  q92, replace
destring  q93, replace
destring  q94, replace
destring  q95, replace
destring  q96, replace
destring  q97, replace
destring  q98, replace
destring  q99, replace
destring  q100, replace 
destring  q101, replace 
destring  q102, replace 
destring  q103, replace
destring  q104, replace
destring  q105, replace
destring  q106, replace
destring  q107, replace



* Apply labels to variables
label values q18 agreement
label values q19 agreement
label values q20 agreement
label values q21 agreement
label values q22 agreement
label values q23 agreement
label values q24 agreement
label values q25 agreement
label values q26 agreement
label values q27 agreement
label values q28 agreement
label values q29 agreement
label values q30 agreement
label values q31 agreement
label values q32 agreement
label values q33 agreement
label values q34 agreement
label values q35 agreement
label values q36 agreement
label values q41 agreement
label values q42 agreement
label values q43 agreement
label values q44 agreement
label values q45 agreement
label values q46 agreement
label values q47 agreement
label values q48 agreement
label values q49 agreement
label values q50 agreement
label values q51 agreement
label values q52 agreement
label values q113 agreement
label values q114 agreement
label values q115 agreement
label values q116 agreement
label values q117 agreement
label values q118 agreement
label values q119 agreement
label values q120 agreement
label values q121 agreement
label values q122 agreement
label values q123 agreement
label values q124 agreement

label values q60 attackers
label values q61 attackers
label values q62 attackers
label values q63 attackers
label values q64 attackers
label values q65 attackers
label values q67 attackers
label values q68 attackers
label values q69 attackers
label values q70 attackers
label values q71 attackers
label values q72 attackers
label values q74 attackers
label values q75 attackers
label values q77 attackers
label values q78 attackers
label values q79 attackers

*! Define missing values
mvdecode *, mv(-1)
preserve
