export DATE=`date '+%d%b%Y-%H%M'`
export DATE_SHORT=`date '+%d%b'`

echo "usage: perl GenerateAll.sh [path to nph-dumpsurveysubsection.pl]"
echo 
echo "Generating formatted data files..."
echo
echo "perl SiteUseAndPopularity.pl > $DATE-use.txt"
perl SiteUseAndPopularity.pl > $DATE-use.txt
echo "   $DATE-use.txt...done."
echo "perl LoginStats.pl > $DATE-login.txt"
perl LoginStats.pl > $DATE-login.txt
echo "   $DATE-login.txt...done."
echo "perl PasswordEstimations.pl > $DATE-estimations.txt"
perl PasswordEstimations.pl > $DATE-estimations.txt
echo "   $DATE-estimations.txt...done."

if [ -f "$1" ]
then
	# There's an unfortunate addition of quotation marks that
	# makes importing the data difficult for programs like Excel and Stata
	# This removes the characters
	echo "tr -d '\"' $1 > tmp.txt"
	tr -d '"' < $1 > tmp.txt
    echo "perl AddVariables.pl < tmp.txt > $DATE-DumpSurvey.txt"
    perl AddVariables.pl < tmp.txt > $DATE-DumpSurvey.txt
	echo "rm tmp.txt"
	rm tmp.txt
    echo "$DATE-DumpSurvey.txt...done."
#    echo "rm $1"
#    rm $1
    echo "...done."
else
	echo "$DATE-DumpSurvey.txt...Survey data was not supplied."
fi

#echo "mv *.txt DataDumps"
#mv *.txt DataDumps
echo "...done"
echo
echo "End of script."

