#!/usr/local/bin/perl -w

use CGI qw/:standard/;
use strict;

require UID;

my $mixedFile = "-mixed.dat";
######################################################################
# collectSiteUseAndPopularity
######################################################################
# All websites checked by the user, but only unique ones, mixed so the order
# is randomized
# Collect how many unique websites each participant uses
sub collectSiteUseAndPopularity(\$ \$ \% \%) { 
	my ($uidRef, $fileRef, $infoRef, $popularityRef) = @_;

	if(-f $$fileRef) {
		open(INFH, "<$$fileRef") || die ("Cannot open $$fileRef");
		my @websiteTriplets = <INFH>;
		close(INFH);

		chomp(@websiteTriplets);

		foreach (@websiteTriplets) {
			
			# Entries are in the format (title, URL, index, doneBit)
			if( /^\((.*), (.*), (\d+), 1\)/ ) {
				if( defined $popularityRef->{$3} ) {
					my ($title, $URL, $hits) = @{$popularityRef->{$3}};
					$popularityRef->{$3} = [$title, $URL, ++$hits];
				} else {
					$popularityRef->{$3} = [$1, $2, 1];
				}
				$infoRef->{$$uidRef}->{'NumSites'}++;
			} else {
				print STDERR "-*- Participant $$uidRef did not finish site $1, $3 -*-\n";
			}
		}
	}
}

######################################################################
# main
######################################################################
package main;
{
    my $dir = $UID::dir;
	my @UID = UID::collectUIDs(\$dir);

	my %userInfo = (); 
	my %sitePopularity = ();
    print "UID\tNumWebsitesTask\n";
	foreach my $uid (@UID) {
		my $responseDir = "$UID::dir/$uid";
		my $file = "$responseDir/$uid$mixedFile";
		collectSiteUseAndPopularity($uid, $file, %userInfo, %sitePopularity);
		print "$uid\t$userInfo{$uid}->{'NumSites'}\n";
	}
}
