#!/usr/local/bin/perl -w
use CGI qw/:standard/;
use strict;
use Fcntl ':flock'; # use LOCK_* constants for file locking
use DataManip;

alarm(60); # initiate a self-struction after 60 seconds

######################################################################
# main
######################################################################
# Startup a log with a specific participant's information
my $query = CGI->new();

if($query->param('id')) {
    # Verify ID is one of the accepted ones before moving on
    my $id = $query->param('id');
    my $retval = id_ok($id);
    if ( $retval != 1 ) {
		my $msg = "ID number $id is not recognized.";
		display_error_page($msg);
		exit;
    }
    my $dumpFile = "responses/$id-policy.dat";

    open(OUTFH, ">>$dumpFile") || die("Can't open $dumpFile for recording submission: $!");

    my $file = "PolicyLogic2.txt";
    open(INFH, "<$file") || die ("Can't open $file: $!");
    my @input = <INFH>;
    my @labels = ();
# File is in the format line1 = label\tquestion; line2,3,4 = answers (tab delimited)
    for(my $i = 0; $i + 4 <= $#input; $i = $i + 4) {
	chomp($input[$i]);
	my ($label, $tmp) = split(/\t/, $input[$i]);
	push(@labels, $label);
    }

# Startup a log with a specific participant's information
    my $query = CGI->new();
    my @results = ();
    foreach my $l (@labels) {
	# Retreive the ranking of the passwords
	my @order = ();
	for(my $i = 0; $i < 3; $i++) {
	    push(@order, $query->param("$l-$i") );
	}
	my $explanation = $query->param("$l-text");
	push(@results, [$l, \@order, $explanation] );
    }

# Now create the webpage for asking the questions
    print CGI::header();
    print CGI::start_html('-title' => "Policy Logic Questions");
    print CGI::h1("Thank you for participating!");

    print "This is what we have recorded as your answers: \n";
    print "<table border=1>\n";
    print CGI::Tr(CGI::th("First choice (Most secure)"),
		  CGI::th("Second choice"),
		  CGI::th("Third choice (Least secure)"),
		  CGI::th("Explanation of ranking") ), "\n";
    foreach my $r (@results) {
	print OUTFH "$r->[0]\t";
	print OUTFH "$r->[1]->[0]\t";
	print OUTFH "$r->[1]->[1]\t";
	print OUTFH "$r->[1]->[2]\t";
	print OUTFH "$r->[2]\n";
	print CGI::Tr(CGI::td($r->[1]->[0]),
		      CGI::td($r->[1]->[1]),
		      CGI::td($r->[1]->[2]),
		      CGI::td($r->[2]) ), "\n";
    }
    close(OUTFH);

    print "</table>\n";
    print CGI::end_html(), "\n";
} else {
    my $msg = "Unable to process submission without ID information";
    display_error_page($msg);
}
