using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PrivacyGuard
{
	/// <summary>
	/// Summary description for AnnotationLayer.
	/// </summary>
	public class AnnotationLayer : System.Windows.Forms.Form
	{
		public const int ANIMATIONLENGTH = 10;
		public const int DATAFILLINGLENGTH = 10;
		public const double OPAQUE = 0.5;
		private PrivacyGuard.AnnotationToolkit.AnimationChar animationChar = null;
		public PrivacyGuard.AnnotationToolkit.AnimationChar AnimationChar 
		{
			get 
			{
				return this.animationChar;
			}
			set
			{
				this.animationChar = value;
			}
		}
		private PrivacyGuard.AnnotationToolkit.AnimationIcon animationIcon = null;
		public PrivacyGuard.AnnotationToolkit.AnimationIcon AnimationIcon 
		{
			get 
			{
				return this.animationIcon;
			}
			set 
			{
				this.animationIcon = value;
			}
		}

		public static Rectangle INVALIDRECT = new Rectangle(0, 0, 0, 0);
//		private Rectangle dataFillingRectStart = INVALIDRECT;
//		public Rectangle DataFillingRectStart 
//		{
//			get 
//			{
//				return this.dataFillingRectStart;
//			}
//			set 
//			{
//				this.dataFillingRectStart = value;
//			}
//		}
//		private Rectangle dataFillingRectEnd = INVALIDRECT;
//		public Rectangle DataFillingRectEnd 
//		{
//			get 
//			{
//				return this.dataFillingRectEnd;
//			}
//			set 
//			{
//				this.dataFillingRectEnd = value;
//			}
//		}
		private Rectangle dataFillingRectCurr = INVALIDRECT;
		private SolidBrush rectBrush;
		private Pen rectPen;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AnnotationLayer()
		{
			this.rectBrush = new SolidBrush(Color.LightGreen);
			this.rectPen = new Pen(Color.LightGreen, 5);
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			SetStyle(ControlStyles.DoubleBuffer, true);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// AnnotationLayer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1024, 768);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "AnnotationLayer";
			this.Text = "AnnotationLayer";
			this.TopMost = true;
			this.TransparencyKey = System.Drawing.SystemColors.Control;
			this.Opacity = OPAQUE;
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
		}
		#endregion

		public void DisplayAnimationIcon() 
		{
			if (this.animationIcon != null) 
			{
				double inid = 0.0f;
				double fnld = 1.0f;
				double dd = (fnld-inid)/(double)ANIMATIONLENGTH;
				for (double cd = dd; cd <= fnld; cd += dd) 
				{
					System.Threading.Thread.Sleep(20);
					if (this.animationIcon.InvalidateIcon) 
					{
						cd = dd;
						this.animationIcon.InvalidateIcon = false;
					}
					this.animationIcon.UpdateAnimation(cd);
					this.Refresh();
				}
				this.animationIcon = null;
				this.Refresh();
			}
		}

		public void DisplayAnimationChar() 
		{
			if (this.animationChar != null) 
			{
				double inid = 0.0f;
				double fnld = Math.PI/2.0f;
				double dd = (fnld-inid)/(double)ANIMATIONLENGTH;
				for (double cd = dd; cd <= fnld; cd += dd) 
				{
					System.Threading.Thread.Sleep(20);
					if (this.animationChar.InvalidateChar) 
					{
						cd = dd;
						this.animationChar.InvalidateChar = false;
					}
					this.animationChar.UpdateAnimation(cd);
					//System.Threading.Thread.Sleep(1000);
					this.Refresh();
				}
				this.animationChar = null;
				this.Refresh();
			}
		}

		protected override void OnPaint(PaintEventArgs pe) 
		{
			Graphics g = pe.Graphics;
			if (this.animationChar != null) 
			{
				this.animationChar.DisplayAnimation(g);
			}
			if (this.animationIcon != null) 
			{
				this.animationIcon.DisplayAnimation(g);
			}
			if (!this.dataFillingRectCurr.Equals(INVALIDRECT)) 
			{
				g.FillRectangle(this.rectBrush, this.dataFillingRectCurr);
				//g.DrawRectangle(this.rectPen, this.dataFillingRectCurr);
			}
		}

		public void DisplayDataFilling(Rectangle start, Rectangle end) 
		{
			//			if (!this.dataFillingRectStart.Equals(INVALIDRECT) &&
			//				!this.dataFillingRectEnd.Equals(INVALIDRECT)) 
			//			{
			//				int startX = this.dataFillingRectStart.X;
			//				int endX = this.dataFillingRectEnd.X;
			//				int startY = this.dataFillingRectStart.Y;
			//				int endY = this.dataFillingRectEnd.Y;
			//				int startW = this.dataFillingRectStart.Width;
			//				int endW = this.dataFillingRectEnd.Width;
			//				int startH = this.dataFillingRectStart.Height;
			//				int endH = this.dataFillingRectEnd.Height;
			//				for (int i = 0; i < DATAFILLINGLENGTH; i++) 
			//				{
			//					System.Threading.Thread.Sleep(20);
			//					int currX= startX+(endX-startX)*i/DATAFILLINGLENGTH;
			//					int currY= startY+(endY-startY)*i/DATAFILLINGLENGTH;
			//					int currW= startW+(endW-startW)*i/DATAFILLINGLENGTH;
			//					int currH= startH+(endH-startH)*i/DATAFILLINGLENGTH;
			//					this.dataFillingRectCurr = new Rectangle(currX, currY, currW, currH);
			//					this.Refresh();
			//				}
			//				this.dataFillingRectCurr = INVALIDRECT;
			//				this.Refresh();
			//			}
			int startX = start.X;
			int endX = end.X;
			int startY = start.Y;
			int endY = end.Y;
			int startW = start.Width;
			int endW = end.Width;
			int startH = start.Height;
			int endH = end.Height;
			for (int i = 0; i < DATAFILLINGLENGTH; i++) 
			{
				int currX= startX+(endX-startX)*i/DATAFILLINGLENGTH;
				int currY= startY+(endY-startY)*i/DATAFILLINGLENGTH;
				int currW= startW+(endW-startW)*i/DATAFILLINGLENGTH;
				int currH= startH+(endH-startH)*i/DATAFILLINGLENGTH;
				this.dataFillingRectCurr = new Rectangle(currX, currY, currW, currH);
				this.Refresh();
			}
			this.dataFillingRectCurr = INVALIDRECT;
			this.Refresh();
		}
	}
}
