using System;
using System.Drawing;

namespace PrivacyGuard.AnnotationToolkit
{
	/// <summary>
	/// Summary description for AnimationChar.
	/// </summary>
	abstract public class AnimationChar
	{
		protected string letter;
		protected Point currPos;
		protected Point orgPos;
		protected Point destPos;
		protected StringFormat drawFmt;
		protected bool invalidateChar = false;
		public bool InvalidateChar 
		{
			get 
			{
				return this.invalidateChar;
			}
			set 
			{
				this.invalidateChar = value;
			}
		}

		public AnimationChar(string l, Point o, Point d) 
		{
			this.letter = l;
			this.orgPos = o;
			this.destPos = d;
			this.drawFmt = new StringFormat();
			this.drawFmt.Alignment = StringAlignment.Center;
			this.drawFmt.LineAlignment = StringAlignment.Center;
		}

		abstract public void UpdateAnimation(double step);
		abstract public void DisplayAnimation(Graphics g);
		abstract public void UpdateChar(AnimationChar c);
	}
}
