using System;
using System.Collections;
using System.IO;

namespace PrivacyGuard.BackEndImpl
{
	/// <summary>
	/// Summary description for SecureStorage.
	/// </summary>
	public class SecureStorage
	{
		public const string DEFAULTSCOPE = "";

		// loginTable: [domain -> [auth scope -> password+]]
		private Hashtable loginTable;
		private Hashtable passwordTable;

		private string aed = "ae.com";
		private string aeid = "john_smith_1170@hotmail.com";
		private string aep = "";

		private string amazond = "amazon.com";
		private string amazonid = "john_smith_1170@hotmail.com";
		private string amazonp = "";

		private string appled = "apple.com";
		private string appleid = "john_smith_1170@hotmail.com";
		private string applep = "";

		private string bestbuyd = "bestbuy.com";
		private string bestbuyid = "john_smith_1170@hotmail.com";
		private string bestbuyp = "";

		private string bloomingdalesd = "bloomingdales.com";
		private string bloomingdalesid = "john_smith_1170@hotmail.com";
		private string bloomingdalesp = "";

		private string buyd = "buy.com";
		private string buyid = "john_smith_1170@hotmail.com";
		private string buyp = "";

		private string compusad = "compusa.com";
		private string compusaid = "john_smith_1170@hotmail.com";
		private string compusap = "";

		private string dddvdd = "deepdiscountdvd.com";
		private string dddvdid = "john_smith_1170@hotmail.com";
		private string dddvdp = "";

		private string dvdplanetd = "dvdplanet.com";
		private string dvdplanetid = "john_smith_1170@hotmail.com";
		private string dvdplanetp = "";

		private string ebgamesd = "ebgames.com";
		private string ebgamesid = "john_smith_1170@hotmail.com";
		private string ebgamesp = "";

		private string hsnd = "hsn.com";
		private string hsnid = "john_smith_1170@hotmail.com";
		private string hsnp = "";

		private string kbtoysd = "kbtoys.com";
		private string kbtoysid = "john_smith_1170@hotmail.com";
		private string kbtoysp = "";

		private string kmartd = "kmart.com";
		private string kmartid = "john_smith_1170@hotmail.com";
		private string kmartp = "";

		private string macysd = "macys.com";
		private string macysid = "john_smith_1170@hotmail.com";
		private string macysp = "";

		private string paypald = "paypal.com";
		private string paypalid = "john_smith_1170@hotmail.com";
		private string paypalp = "";

		private string pcconnectiond = "pcconnection.com";
		private string pcconnectionid = "john_smith_1170@hotmail.com";
		private string pcconnectionp = "";

		private string radioshackd = "radioshack.com";
		private string radioshackid = "john_smith_1170@hotmail.com";
		private string radioshackp = "";

		private string staplesd = "staples.com";
		private string staplesid = "john_smith_1170@hotmail.com";
		private string staplesp = "";

		private string targetd = "target.com";
		private string targetid = "john_smith_1170@hotmail.com";
		private string targetp = "";

		private string travelocityd = "travelocity.com";
		private string travelocityid = "john_smith_1170@hotmail.com";
		private string travelocityp = "";

		private string yahood = "yahoo.com";
		private string yahooid = "john_smith_1170";
		private string yahoop = "";

		public class LoginRecord
		{
			private string id;
			public string Id 
			{
				get 
				{
					return this.id;
				}
			}
			// [auth scope -> password+]
			private Hashtable passwords;
			public Hashtable Passwords 
			{
				get 
				{
					return this.passwords;
				}
			}

			public LoginRecord(string d, string password) 
			{
				this.id = d;
				this.passwords = new Hashtable();
				ArrayList a = new ArrayList();
				a.Add(password);
				this.passwords.Add(SecureStorage.DEFAULTSCOPE, a);
			}
			public LoginRecord(string d, Hashtable ps) 
			{
				this.id = d;
				this.passwords = ps;
			}
			public LoginRecord(string d, string p, string s)
			{
				this.id = d;
				this.passwords = new Hashtable();
				ArrayList a = new ArrayList();
				a.Add(p);
				this.passwords.Add(s, a);
			}
			public ArrayList GetPasswordsUnderDomain () 
			{
				return (ArrayList) this.passwords[SecureStorage.DEFAULTSCOPE];
			}
			public ArrayList GetPasswordsUnderAuthscope (string s) 
			{
				return (ArrayList) this.passwords[s];
			}
			public void UpdateRecord(LoginRecord r) 
			{
				IDictionaryEnumerator idnum = r.passwords.GetEnumerator();
				while (idnum.MoveNext()) 
				{
					if (this.passwords.Contains(idnum.Key)) 
						this.passwords[idnum.Key] = idnum.Value;
					else
						this.passwords.Add(idnum.Key, idnum.Value);
				}
			}		
		}

		public class LoginToken 
		{
			private string id;
			public string Id 
			{
				get 
				{
					return this.id;
				}
			}
			private ArrayList passwords;
			public ArrayList Passwords 
			{
				get 
				{
					return this.passwords;
				}
			}
			public LoginToken(string id, ArrayList ps) 
			{
				this.id = id;
				this.passwords = ps;
			}
		}

		public SecureStorage()
		{
			InitializeLoginTable();
		}

		private void InitializeLoginTable() 
		{
			this.passwordTable = new Hashtable();
			this.passwordTable.Add(aed, new LoginRecord(aeid, aep));
			this.passwordTable.Add(amazond, new LoginRecord(amazonid, amazonp));
			this.passwordTable.Add(appled, new LoginRecord(appleid, applep));
			this.passwordTable.Add(bestbuyd, new LoginRecord(bestbuyid, bestbuyp));
			this.passwordTable.Add(bloomingdalesd, new LoginRecord(bloomingdalesid, bloomingdalesp));
			this.passwordTable.Add(buyd, new LoginRecord(buyid, buyp));
			this.passwordTable.Add(compusad, new LoginRecord(compusaid, compusap));
			this.passwordTable.Add(dddvdd, new LoginRecord(dddvdid, dddvdp));
			this.passwordTable.Add(dvdplanetd, new LoginRecord(dvdplanetid, dvdplanetp));
			this.passwordTable.Add(ebgamesd, new LoginRecord(ebgamesid, ebgamesp));
			this.passwordTable.Add(hsnd, new LoginRecord(hsnid, hsnp));
			this.passwordTable.Add(kbtoysd, new LoginRecord(kbtoysid, kbtoysp));
			this.passwordTable.Add(kmartd, new LoginRecord(kmartid, kmartp));
			this.passwordTable.Add(macysd, new LoginRecord(macysid, macysp));
			this.passwordTable.Add(paypald, new LoginRecord(paypalid, paypalp));
			this.passwordTable.Add(pcconnectiond, new LoginRecord(pcconnectionid, pcconnectionp));
			this.passwordTable.Add(radioshackd, new LoginRecord(radioshackid, radioshackp));
			this.passwordTable.Add(staplesd, new LoginRecord(staplesid, staplesp));
			this.passwordTable.Add(targetd, new LoginRecord(targetid, targetp));
			this.passwordTable.Add(travelocityd, new LoginRecord(travelocityid, travelocityp));
			this.passwordTable.Add(yahood, new LoginRecord(yahooid, yahoop));

			this.loginTable = new Hashtable();
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				StreamReader sr = File.OpenText(@"C:\VisualStudio\PrivacyGuard\status\config\current\cards.txt");
				string str = sr.ReadLine();
				while (str != null) 
				{
					if (str.Equals("ae.com"))
						this.loginTable.Add(aed, new LoginRecord(aeid, aep));
					else if (str.Equals("amazon.com"))
						this.loginTable.Add(amazond, new LoginRecord(amazonid, amazonp));
					else if (str.Equals("apple.com"))
						this.loginTable.Add(appled, new LoginRecord(appleid, applep));
					else if (str.Equals("bestbuy.com"))
						this.loginTable.Add(bestbuyd, new LoginRecord(bestbuyid, bestbuyp));
					else if (str.Equals("bloomingdales.com"))
						this.loginTable.Add(bloomingdalesd, new LoginRecord(bloomingdalesid, bloomingdalesp));
					else if (str.Equals("buy.com"))
						this.loginTable.Add(buyd, new LoginRecord(buyid, buyp));
					else if (str.Equals("compusa.com"))
						this.loginTable.Add(compusad, new LoginRecord(compusaid, compusap));
					else if (str.Equals("deepdiscountdvd.com"))
						this.loginTable.Add(dddvdd, new LoginRecord(dddvdid, dddvdp));
					else if (str.Equals("dvdplanet.com"))
						this.loginTable.Add(dvdplanetd, new LoginRecord(dvdplanetid, dvdplanetp));
					else if (str.Equals("ebgames.com"))
						this.loginTable.Add(ebgamesd, new LoginRecord(ebgamesid, ebgamesp));
					else if (str.Equals("hsn.com"))
						this.loginTable.Add(hsnd, new LoginRecord(hsnid, hsnp));
					else if (str.Equals("kbtoys.com"))
						this.loginTable.Add(kbtoysd, new LoginRecord(kbtoysid, kbtoysp));
					else if (str.Equals("kmart.com"))
						this.loginTable.Add(kmartd, new LoginRecord(kmartid, kmartp));
					else if (str.Equals("macys.com"))
						this.loginTable.Add(macysd, new LoginRecord(macysid, macysp));
					else if (str.Equals("pcconnect.com"))
						this.loginTable.Add(pcconnectiond, new LoginRecord(pcconnectionid, pcconnectionp));
					else if (str.Equals("radioshack.com"))
						this.loginTable.Add(radioshackd, new LoginRecord(radioshackid, radioshackp));
					else if (str.Equals("staples.com"))
						this.loginTable.Add(staplesd, new LoginRecord(staplesid, staplesp));
					else if (str.Equals("target.com"))
						this.loginTable.Add(targetd, new LoginRecord(targetid, targetp));
					else if (str.Equals("travelocity.com"))
						this.loginTable.Add(travelocityd, new LoginRecord(travelocityid, travelocityp));
					else if (str.Equals("yahoo.com"))
						this.loginTable.Add(yahood, new LoginRecord(yahooid, yahoop));

					str = sr.ReadLine();
				}
				sr.Close();
			}
		}
		public LoginToken ContainsLoginRecord(string domain) 
		{
			LoginRecord r = (LoginRecord) this.loginTable[domain];
			if (r != null) 
			{
				ArrayList al = (ArrayList) (r.Passwords)[SecureStorage.DEFAULTSCOPE];
				if (al != null)
					return new LoginToken (r.Id, al);
			}
			return null;
		}
		public LoginToken ContainsLoginRecord(string domain, string authscope) 
		{
			LoginRecord r = (LoginRecord) this.loginTable[domain];
			if (r != null) 
			{
				ArrayList al = (ArrayList) (r.Passwords)[authscope];
				if (al != null)
					return new LoginToken (r.Id, al);
			}
			return null;
		}
		public void UpdateLoginRecord(string domain, LoginRecord r) 
		{
			if (this.loginTable.Contains(domain)) 
			{
				((LoginRecord) this.loginTable[domain]).UpdateRecord(r);
			}
			else 
			{
				this.loginTable.Add(domain, r);
			}
		}

		public ArrayList getDomains() 
		{
			ArrayList a = new ArrayList();
			IDictionaryEnumerator ide = this.loginTable.GetEnumerator();
			while (ide.MoveNext())
				a.Add((string)ide.Key);
			a.Sort();
			return a;
		}

		public string GetRealPassword(string domain) 
		{
			if (this.passwordTable.Contains(domain)) 
			{
				LoginRecord lr = (LoginRecord) this.passwordTable[domain];
				ArrayList al = lr.GetPasswordsUnderDomain();
				return (string) al[0];
			}
			else
				return "";
		}
		public void AddtoLookupTable(string claimedd, string actuald, string id, string pwd) 
		{
			if (this.passwordTable.Contains(actuald)) 
			{
				LoginRecord lr = (LoginRecord) this.passwordTable[actuald];
				string lrid = lr.Id;
				if (IEBrowser.WEBWALLETSTUDY) 
				{
					if (lrid.Equals(id))
					{
						if (this.loginTable.Contains(claimedd)) 
						{
							loginTable[claimedd] = new LoginRecord(id, pwd);
						} 
						else 
						{
							loginTable.Add(claimedd, new LoginRecord(id, pwd));
						}
					}
				} 
				else 
				{
					ArrayList al = lr.GetPasswordsUnderDomain();
					string lrpwd = (string) al[0];
					if (lrid.Equals(id) && lrpwd.Equals(pwd)) 
					{
						if (this.loginTable.Contains(claimedd)) 
						{
							loginTable[claimedd] = new LoginRecord(id, pwd);
						} 
						else 
						{
							loginTable.Add(claimedd, new LoginRecord(id, pwd));
						}
					}
				}
			}					
		}
	}
}
