using System;
using System.Collections;
using mshtml;

namespace PrivacyGuard.ConfirmationToolkit
{
	/// <summary>
	/// Summary description for ConfirmationTrigger.
	/// </summary>
	public class ConfirmationTrigger
	{
		private Hashtable lookupTable;
		private IEBrowser browser;

		public ConfirmationTrigger()
		{
			this.lookupTable = new Hashtable();
			InitializeLookupTable();
		}

		private void InitializeLookupTable() 
		{
			this.lookupTable.Add("amazon.com", "Continue");
		}

		public bool ContinueProcess(IEBrowser b, IHTMLElement src) 
		{
			this.browser = b;

			//IHTMLDocument2 doc = (IHTMLDocument2) this.browser.BrowsingWindow.Document;
			IHTMLDocument2 doc = (IHTMLDocument2) this.browser.GetDocument();
			if (doc == null || src == null)
				return true;

			//string protocol = doc.protocol;
			string protocol = this.browser.GetProtocol(false);
			if (protocol.Equals("HyperText Transfer Protocol with Privacy")) 
				return true;

			//string url = doc.url;

			if (!(src is IHTMLInputElement))
				return true;

			IHTMLInputElement input = src as IHTMLInputElement;
			
			//string domainname = PrivacyGuard.PrivacyGuardUtils.IEUtil.GetDomainName(url);
			string domainname = this.browser.GetDomainName(true);
			
			bool showdlg = HardcodedAnalyze(domainname, input);
			if (showdlg) 
			{
				ConfirmationToolkit.ConfirmationDialog confirmdlg = new ConfirmationDialog(this.browser);
				confirmdlg.ShowDialog();
				if (confirmdlg.IsOK) 
				{
					return true;
				} 
				else 
				{
					return false;
				}
			}
			return true;
		}

		private bool HardcodedAnalyze(string domainname, IHTMLInputElement input) 
		{
			string keyword = (string) this.lookupTable[domainname];
			if (keyword == null || !keyword.Equals(input.value))
				return false;
			else 
				return true;
		}
	}
}
