using System;
using System.Drawing;

namespace PrivacyGuard.IEBrowserSecurityToolkit
{
	/// <summary>
	/// Summary description for Warningbar.
	/// </summary>
	public class Warningbar : System.Windows.Forms.Panel
	{
		//public const int FIXEDY = 45;
		public const int FIXEDY = 30;

		private System.Windows.Forms.PictureBox warningIcon;
		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\warning-small.png";
		private string image_uri_2 = @"C:\VisualStudio\PrivacyGuard\images\warning-smaller.png";
		public const int ICONW = 25;
		public const int ICONH = 25;
		public const int ICONX = 10;
		public const int ICONY = 2;

//		private System.Windows.Forms.Label untrustedLabel1;
//		private System.Windows.Forms.Label untrustedLabel2;
//		private System.Windows.Forms.LinkLabel untrustedLabel3;

		private System.Windows.Forms.LinkLabel help;
		public System.Windows.Forms.LinkLabel Help 
		{
			get 
			{
				return this.help;
			}
		}

		public const int FONTSIZE = 8;
		public const string FONTNAME = "Tahoma";
		public const int WARNINGW = 850;
		public const int WARNINGH = 13;
		public const int WARNINGX = 50;
		private System.Windows.Forms.Label warningLine1;
		//public const int WARNINGY1 = 17;
		public const int WARNINGY1 = 2;
		public const string WARNINGTEXT1 = @"Always use the Web Wallet (press the F2 key) to protect your sensitive information submission including:";
		private System.Windows.Forms.Label warningLine2;
		//public const int WARNINGY2 = 30;
		public const int WARNINGY2 = 15;
		public const string WARNINGTEXT2 = @"login passwords, credit cards, bank accounts and personal IDs like the Social Security Number";

		private System.Windows.Forms.Label warningLine3;
		public const string WARNINGTEXT3 = @"Your keyboard typing and mouse clicks are going directly to the web site.";

		public const int HIGHLIGHTMAX = 20;
		private int highlightCounter = 0;

		private IEBrowser browser;

		public Warningbar(IEBrowser b)
		{
			this.browser = b;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Size = new Size(PrivacyGuard.IEBrowser.MAXIMIZEDX,	FIXEDY);
			this.Location = new Point(0, 91);
			this.BackColor = Color.LightYellow;
			this.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;

			this.warningIcon = new System.Windows.Forms.PictureBox();
			this.warningIcon.Location = new Point(ICONX, ICONY);
			this.warningIcon.Size = new Size(ICONW, ICONH);
			this.warningIcon.Image = Image.FromFile(image_uri);

//			this.untrustedLabel1 = new System.Windows.Forms.Label();
//			this.untrustedLabel1.Location = new Point(50, 2);
//			this.untrustedLabel1.Size = new Size(80, 13);
//			this.untrustedLabel1.Text = "This web site is";
//			this.untrustedLabel1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
//			this.untrustedLabel1.Font = new Font(FONTNAME, FONTSIZE);
//
//			this.untrustedLabel2 = new System.Windows.Forms.Label();
//			this.untrustedLabel2.Location = new Point(130, 2);
//			this.untrustedLabel2.Size = new Size(110, 13);
//			this.untrustedLabel2.Text = "NOT a trusted site.";
//			this.untrustedLabel2.ForeColor = Color.Red;
//			this.untrustedLabel2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
//			this.untrustedLabel2.Font = new Font(FONTNAME, FONTSIZE, FontStyle.Bold);
//
//			this.untrustedLabel3 = new System.Windows.Forms.LinkLabel();
//			this.untrustedLabel3.Location = new Point(240, 2);
//			this.untrustedLabel3.Size = new Size(50, 13);
//			this.untrustedLabel3.Text = "(Why?)";
//			this.untrustedLabel3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
//			this.untrustedLabel3.Font = new Font(FONTNAME, FONTSIZE);

			this.help = new System.Windows.Forms.LinkLabel();
			this.help.Location = new Point(this.Width-110, 0);
			this.help.Size = new Size(100, this.Height);
			this.help.Text = "Learn more about\nthe Web Wallet";
			this.help.TextAlign = ContentAlignment.MiddleRight;
			this.help.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.help.Font.Size);
			this.help.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(help_LinkClicked);

			this.warningLine1 = new System.Windows.Forms.Label();
			this.warningLine1.Location = new Point(WARNINGX, WARNINGY1);
			this.warningLine1.Size = new Size(WARNINGW, WARNINGH);
			this.warningLine1.Text = WARNINGTEXT1;
			this.warningLine1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.warningLine1.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, FONTSIZE, FontStyle.Bold);

			this.warningLine2 = new System.Windows.Forms.Label();
			this.warningLine2.Location = new Point(WARNINGX, WARNINGY2);
			this.warningLine2.Size = new Size(WARNINGW, WARNINGH);
			this.warningLine2.Text = WARNINGTEXT2;
			this.warningLine2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.warningLine2.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, FONTSIZE);

			this.warningLine3 = new System.Windows.Forms.Label();
			this.warningLine3.Location = new Point(WARNINGX,WARNINGY1);
			this.warningLine3.Size = new Size(WARNINGW, WARNINGH*2);
			this.warningLine3.Text = WARNINGTEXT3;
			this.warningLine3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.warningLine3.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, 14, FontStyle.Bold);
			this.warningLine3.Hide();

//			this.Controls.Add(this.untrustedLabel1);
//			this.Controls.Add(this.untrustedLabel2);
//			this.Controls.Add(this.untrustedLabel3);
			this.Controls.Add(this.warningLine1);
			this.Controls.Add(this.warningLine2);
			this.Controls.Add(this.warningLine3);
			this.Controls.Add(this.help);
			this.Controls.Add(this.warningIcon);
		}

		public void UpdateHighlight() 
		{
			Color bgcolor = this.BackColor;
			if (highlightCounter <= 0) 
			{
				if (bgcolor.Equals(Color.Yellow))
					this.BackColor = Color.LightYellow;
				this.warningLine1.Show();
				this.warningLine2.Show();
				this.warningLine3.Hide();
			}
			else 
			{
				if (bgcolor.Equals(Color.LightYellow))
					this.BackColor = Color.Yellow;
				this.warningLine1.Hide();
				this.warningLine2.Hide();
				this.warningLine3.Show();
				highlightCounter--;
			}
		}
		public void ActivateHighlight() 
		{
			this.highlightCounter = HIGHLIGHTMAX;
		}

		private void help_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			if (this.Parent == this.browser)
				this.browser.GotoTutorial();
		}

//		protected override void OnPaint(System.Windows.Forms.PaintEventArgs pe) 
//		{
//			Graphics g = pe.Graphics;
//			SolidBrush brush = new SolidBrush(Color.Black);
//			float w = 5.0f;
//			float h = 5.0f;
//			float y = 20.0f;
//			float x = 55.0f;
//			g.FillEllipse(brush, x, y, w, h);
//			x += 50.0f;
//			g.FillEllipse(brush, x, y, w, h);
//			x += 50.0f;
//			g.FillEllipse(brush, x, y, w, h);
//			x += 50.0f;
//			g.FillEllipse(brush, x, y, w, h);
//		}

//		public void Shrink() 
//		{
//			this.Size = new Size(IEBrowser.MAXIMIZEDX-IEBrowser.WEBWALLETW, 20);
//			this.warningIcon.Size = new Size(15,15);
//			this.warningIcon.Image = Image.FromFile(image_uri_2);
//			this.warningIcon.Location = new Point(10, 2);
//			this.untrustedLabel1.Size = new Size(this.untrustedLabel1.Width,16);
//			this.untrustedLabel2.Size = new Size(this.untrustedLabel2.Width,16);
//			this.untrustedLabel3.Size = new Size(this.untrustedLabel3.Width,16);
//			this.warningLine1.Hide();
//			this.warningLine2.Hide();
////			this.Controls.Remove(this.warningLine1);
////			this.Controls.Remove(this.warningLine2);
//		}
//		public void Reset() 
//		{
//			this.Size = new Size(IEBrowser.MAXIMIZEDX, FIXEDY);
//			this.warningIcon.Size = new Size(25, 25);
//			this.warningIcon.Image = Image.FromFile(image_uri);
//			this.warningIcon.Location = new Point(10, 2);
//			this.untrustedLabel1.Size = new Size(this.untrustedLabel1.Width,13);
//			this.untrustedLabel2.Size = new Size(this.untrustedLabel2.Width,13);
//			this.untrustedLabel3.Size = new Size(this.untrustedLabel3.Width,13);
//			this.warningLine1.Show();
//			this.warningLine2.Show();
////			this.Controls.Add(this.warningLine1);
////			this.Controls.Add(this.warningLine2);
//		}
	}
}
