using System;
using System.Drawing;

namespace PrivacyGuard.IEBrowserToolkit
{
	/// <summary>
	/// Summary description for Toolbar.
	/// </summary>
	public class Toolbar : System.Windows.Forms.Panel
	{
		private AxSHDocVw.AxWebBrowser browsingWindow;
		private IEBrowser browser;

		public const int BACKX = 79;
		public const int FORWX = 51;
		public const int HOMEX = 32;
		public const int MIDDLETX = 64;
		public const int RESTTX = 201;
		public const int FIXEDY = 38;

		private System.Windows.Forms.PictureBox back;
		private System.Windows.Forms.PictureBox forw;
		private System.Windows.Forms.PictureBox stop;
		private System.Windows.Forms.PictureBox reload;
		private System.Windows.Forms.PictureBox home;
		private System.Windows.Forms.PictureBox middle_tools;
		private System.Windows.Forms.PictureBox rest_tools;

		private System.Windows.Forms.Button report;

		private string enable_back_image = @"C:\VisualStudio\PrivacyGuard\images\enable_back.png";
		private string active_back_image = @"C:\VisualStudio\PrivacyGuard\images\active_back.png";
		private string enable_forw_image = @"C:\VisualStudio\PrivacyGuard\images\enable_forw.png";
		private string active_forw_image = @"C:\VisualStudio\PrivacyGuard\images\active_forw.png";
		private string enable_reload_image = @"C:\VisualStudio\PrivacyGuard\images\enable_reload.png";
		private string active_reload_image = @"C:\VisualStudio\PrivacyGuard\images\active_reload.png";
		private string enable_home_image = @"C:\VisualStudio\PrivacyGuard\images\enable_home.png";
		private string active_home_image = @"C:\VisualStudio\PrivacyGuard\images\active_home.png";
		private string stop_image = @"C:\VisualStudio\PrivacyGuard\images\stop_button.png";
		//private string middle_image = @"C:\VisualStudio\PrivacyGuard\images\middle_tools.png";
		private string rest_image = @"C:\VisualStudio\PrivacyGuard\images\rest_tools.png";

		public Toolbar(IEBrowser b)
		{
			this.browser = b;
			//this.browsingWindow = this.browser.BrowsingWindow;
			this.browsingWindow = this.browser.GetBrowsingWindow();
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Size = new System.Drawing.Size(PrivacyGuard.IEBrowser.MAXIMIZEDX, FIXEDY);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.back = new System.Windows.Forms.PictureBox();
			this.forw = new System.Windows.Forms.PictureBox();
			this.stop = new System.Windows.Forms.PictureBox();
			this.reload = new System.Windows.Forms.PictureBox();
			this.home = new System.Windows.Forms.PictureBox();
			//this.middle_tools = new System.Windows.Forms.PictureBox();
			this.rest_tools = new System.Windows.Forms.PictureBox();
			this.report = new System.Windows.Forms.Button();

			int startX = 0;
			int startY = 0;
			this.back.Location = new System.Drawing.Point(startX, startY);
			this.back.Name = "back";
			this.back.Image = Image.FromFile(enable_back_image);
			this.back.Size = new System.Drawing.Size(BACKX, FIXEDY);
			this.back.MouseEnter += new System.EventHandler(this.back_MouseEnter);
			this.back.MouseLeave += new System.EventHandler(this.back_MouseLeave);
			this.back.Click += new System.EventHandler(this.back_Click);

			startX += BACKX;
			this.forw.Location = new System.Drawing.Point(startX, startY);
			this.forw.Name = "forw";
			this.forw.Image = Image.FromFile(enable_forw_image);
			this.forw.Size = new System.Drawing.Size(FORWX, FIXEDY);
			this.forw.MouseEnter += new System.EventHandler(this.forw_MouseEnter);
			this.forw.MouseLeave += new System.EventHandler(this.forw_MouseLeave);
			this.forw.Click += new System.EventHandler(this.forw_Click);

			startX += FORWX;
			this.stop.Location = new System.Drawing.Point(startX, startY);
			this.stop.Image = Image.FromFile(stop_image);
			this.stop.Size = new System.Drawing.Size(HOMEX, FIXEDY);

			startX += HOMEX;
			this.reload.Location = new System.Drawing.Point(startX, startY);
			this.reload.Image = Image.FromFile(enable_reload_image);
			this.reload.Size = new System.Drawing.Size(HOMEX, FIXEDY);
			this.reload.MouseEnter += new System.EventHandler(this.reload_MouseEnter);
			this.reload.MouseLeave += new System.EventHandler(this.reload_MouseLeave);
			this.reload.Click += new System.EventHandler(this.reload_Click);

			startX += HOMEX;
			this.home.Location = new System.Drawing.Point(startX, startY);
			this.home.Name = "home";
			this.home.Image = Image.FromFile(enable_home_image);
			this.home.Size = new System.Drawing.Size(HOMEX, FIXEDY);
			this.home.MouseEnter += new System.EventHandler(this.home_MouseEnter);
			this.home.MouseLeave += new System.EventHandler(this.home_MouseLeave);
			this.home.Click += new System.EventHandler(this.home_Click);

			startX += HOMEX;
			this.rest_tools.Location = new System.Drawing.Point(startX, startY);
			this.rest_tools.Name = "rest_tools";
			this.rest_tools.Image = Image.FromFile(rest_image);
			this.rest_tools.Size = new System.Drawing.Size(RESTTX, FIXEDY);

			this.report = new System.Windows.Forms.Button();
			this.report.Location = new Point(450, 6);
			this.report.Size = new Size(100, 25);
			this.report.Text = "Report Fraud";
			this.report.Font = new Font("Tahoma", this.report.Font.Size, System.Drawing.FontStyle.Bold);
			this.report.TextAlign = ContentAlignment.MiddleCenter;
			this.report.Click += new EventHandler(report_Click);

			this.Controls.Add(back);
			this.Controls.Add(forw);
			//this.Controls.Add(middle_tools);
			this.Controls.Add(stop);
			this.Controls.Add(reload);
			this.Controls.Add(home);
			this.Controls.Add(rest_tools);
			this.Controls.Add(this.report);
		}

		private void back_MouseEnter(object sender, System.EventArgs e)
		{
			this.back.Image = Image.FromFile(active_back_image);
		}

		private void back_MouseLeave(object sender, System.EventArgs e)
		{
			this.back.Image = Image.FromFile(enable_back_image);
		}

		private void forw_MouseEnter(object sender, System.EventArgs e)
		{
			this.forw.Image = Image.FromFile(active_forw_image);
		}

		private void forw_MouseLeave(object sender, System.EventArgs e)
		{
			this.forw.Image = Image.FromFile(enable_forw_image);
		}

		private void reload_MouseEnter(object sender, System.EventArgs e)
		{
			this.reload.Image = Image.FromFile(active_reload_image);
		}

		private void reload_MouseLeave(object sender, System.EventArgs e)
		{
			this.reload.Image = Image.FromFile(enable_reload_image);
		}

		private void home_MouseEnter(object sender, System.EventArgs e)
		{
			this.home.Image = Image.FromFile(active_home_image);
		}

		private void home_MouseLeave(object sender, System.EventArgs e)
		{
			this.home.Image = Image.FromFile(enable_home_image);
		}

		private void back_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				this.browsingWindow.GoBack();
			}
			catch (Exception ex) 
			{
			}
		}

		private void forw_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				this.browsingWindow.GoForward();
			}
			catch (Exception ex) 
			{
			}
		}

		private void reload_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				this.browser.GotoUrl(this.browsingWindow.LocationURL);
			}
			catch (Exception ex) 
			{
			}
		}

		private void home_Click(object sender, System.EventArgs e) 
		{
			try 
			{
				//this.browsingWindow.Navigate(IEBrowser.HOME_URI, ref IEBrowser.nobj, ref IEBrowser.nobj, ref IEBrowser.nobj, ref IEBrowser.nobj);
				this.browser.GoHome();
			}
			catch (Exception ex) 
			{
			}
		}

		private void report_Click(object sender, System.EventArgs e) 
		{
			ReportFraudDialog d = new ReportFraudDialog();
			d.ShowDialog();
			this.browser.GetFocus();
		}
	}
}
