using System;
using System.Collections;
using System.Drawing;
using System.Text.RegularExpressions;
using mshtml;

namespace PrivacyGuard.PrivacyGuardUtils
{
	/// <summary>
	/// Summary description for IEUtil.
	/// </summary>
	public class IEUtil
	{
		static public string GetUrl(string domain) 
		{
			string url = @"http://www." + domain + "/"; 
			return url;
		}

		static public string GetPhishingUrl(string url, string phishinghost) 
		{
			string webPat = @"(\w+)://([^/]+)/(\S*)";
			Match urlMatch = Regex.Match(url, webPat, RegexOptions.IgnoreCase);
			if (urlMatch.Success) 
			{
				string suffix = urlMatch.Groups[3].ToString();
				string phishingurl = @"http://" + phishinghost + "/" + suffix;
				return phishingurl;
			} 
			else
				return url;
		}
		static public string GetDomainName(string url) 
		{
			string webPat = @"(\w+)://([^/]+)/(\S*)";
			Match urlMatch = Regex.Match(url, webPat, RegexOptions.IgnoreCase);
			if (urlMatch.Success) 
			{
				string hostname = urlMatch.Groups[2].ToString();
				string ipPat = @"(\d+).(\d+).(\d+).(\d+)";
				Match ipMatch = Regex.Match(hostname, ipPat, RegexOptions.IgnoreCase);
				if (ipMatch.Success) 
				{
					return hostname;
				} 
				else 
				{
					string[] s = Regex.Split(hostname, Regex.Escape("."));
					int size = s.Length;
					string domainname = s[size-2] + "." + s[size-1];
					return domainname;
				}
			} 
			else 
			{
				return null;
			}
		}

		static public string GetProtocolasPrefix(string url) 
		{
			string webPat = @"(\w+)://([^/]+)/(\S*)";
			Match urlMatch = Regex.Match(url, webPat, RegexOptions.IgnoreCase);
			if (urlMatch.Success) 
			{
				return urlMatch.Groups[1].ToString();
			} 
			else 
			{
				return null;
			}
		}

		static public PrivacyGuard.AnnotationToolkit.AnimationIcon
			FormAnimationIcon(PrivacyGuard.IEBrowserSecurityToolkit.Warningbar warningBar, 
			AxSHDocVw.AxWebBrowser browsingWindow, Point p) 
		{
			Point d;

			IHTMLDocument2 doc = (IHTMLDocument2) browsingWindow.Document;
			if (doc == null)
				return null;
			Rectangle wbRect = warningBar.RectangleToScreen(warningBar.ClientRectangle);
			d = new Point((wbRect.Left + wbRect.Width/2), wbRect.Bottom);
			return new PrivacyGuard.AnnotationToolkit.FlyingIcon(p, d);
		}
		static public PrivacyGuard.AnnotationToolkit.AnimationIcon
			FormAnimationIcon(PrivacyGuard.IEBrowserSecurityToolkit.Warningbar warningBar, 
			Point p) 
		{
			Point d;

			Rectangle wbRect = warningBar.RectangleToScreen(warningBar.ClientRectangle);
			d = new Point((wbRect.Left + wbRect.Width/2), wbRect.Bottom);
			return new PrivacyGuard.AnnotationToolkit.FlyingIcon(p, d);
		}

		static public PrivacyGuard.AnnotationToolkit.AnimationChar 
			FormAnimationChar(AxSHDocVw.AxWebBrowser browsingWindow, string letter) 
		{
			string l = letter;
			Point o;
			Point d;

			// temporarily including the simulated phishing feature here
			bool mask = true;
			IEBrowser b = (IEBrowser) browsingWindow.Parent.Parent;
			PhishingAttacks.PhishingConfig.ATTACKTYPE at = 
				b.Phishingmonitor.GetPhishingType(b.GetDomainName(true));
			if (at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FORM ||
				at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKESUG)
				mask = false;

			IHTMLDocument2 doc = (IHTMLDocument2) browsingWindow.Document;
			if (doc == null)
				return null;
			IHTMLElement ael = doc.activeElement;
			if (ael == null)
				return null;
			if (ael is IHTMLInputElement) 
			{
				IHTMLInputElement inel = ael as IHTMLInputElement;
				if (inel.type.Equals("password") && mask)
					l = "*";
			}
			
			// get dimension of the browsing window
			Rectangle bwRect = browsingWindow.RectangleToScreen(browsingWindow.ClientRectangle);
			d = new Point((bwRect.Left + bwRect.Width/2),
							(bwRect.Top + bwRect.Height/2));

			// get dimension of the active element
			IHTMLRect aeRect = (ael as IHTMLElement2).getBoundingClientRect();
			o = new Point((aeRect.left + bwRect.Left), (aeRect.top + bwRect.Top));

			return new PrivacyGuard.AnnotationToolkit.ZoomingChar(l, o, d);
		}
	}
}
