using System;
using System.Collections;
using System.IO;

namespace PrivacyGuard.UserStudyToolkit
{
	/// <summary>
	/// Summary description for EmailStorage.
	/// </summary>
	public class EmailStorage
	{
		private ArrayList emails;
		public ArrayList Emails 
		{
			get 
			{
				return this.emails;
			}
		}
		private ArrayList dates;

		private string defaultEmailUrl = @"C:\VisualStudio\PrivacyGuard\emails\welcome.html";
		public string DefaultEmailUrl 
		{
			get 
			{
				return this.defaultEmailUrl;
			}
		}

		public class Email 
		{
			private string subject;
			public string Subject 
			{
				get 
				{
					return this.subject;
				}
			}
			private string date;
			public string Date 
			{
				get 
				{
					return this.date;
				}
				set 
				{
					this.date = value;
				}
			}
			private string emailuri;
			public string Emailuri 
			{
				get 
				{
					return this.emailuri;
				}
			}

			public Email(string s, string u) 
			{
				this.subject = s;
				this.emailuri = u;
			}
		}

		public EmailStorage()
		{
			this.emails = new ArrayList();
			this.dates = new ArrayList();
			InitializeData();
		}

		private void InitializeData() 
		{
			StreamReader sr = File.OpenText(@"C:\VisualStudio\PrivacyGuard\status\config\current\emails.txt");
			string str = sr.ReadLine();
			while (str != null) 
			{
				if (str.Equals("ae.com"))
					emails.Add(new Email(@"Fwd: Men's Clearance at American Eagle Outfitters", @"C:\VisualStudio\PrivacyGuard\emails\ae.html"));
				else if (str.Equals("amazon.com"))
					emails.Add(new Email(@"Fwd: New Releases Update", @"C:\VisualStudio\PrivacyGuard\emails\amazon.html"));
				else if (str.Equals("apple.com"))
					emails.Add(new Email(@"Fwd: PowerBook G4 at Apple.com", @"C:\VisualStudio\PrivacyGuard\emails\apple.html"));
				else if (str.Equals("bestbuy.com"))
					emails.Add(new Email(@"Fwd: Featured Digital Cameras at BestBuy", @"C:\VisualStudio\PrivacyGuard\emails\bestbuy.html"));
				else if (str.Equals("bloomingdales.com"))
					emails.Add(new Email(@"Fwd: Men's Sales at Bloomingdale's", @"C:\VisualStudio\PrivacyGuard\emails\bloomingdales.html"));
				else if (str.Equals("buy.com"))
					emails.Add(new Email(@"Fwd: Sporting Equipments at Buy.com", @"C:\VisualStudio\PrivacyGuard\emails\buy.html"));
				else if (str.Equals("compusa.com"))
					emails.Add(new Email(@"Fwd: Recommanded Notebooks at CompUSA", @"C:\VisualStudio\PrivacyGuard\emails\compusa.html"));
				else if (str.Equals("deepdiscountdvd.com"))
					emails.Add(new Email(@"Fwd: DVD Bargains at DeepDiscountDVD", @"C:\VisualStudio\PrivacyGuard\emails\deepdiscountdvd.html"));
				else if (str.Equals("dvdplanet.com"))
					emails.Add(new Email(@"Fwd: Bargain DVD Deals at DVDPLANET", @"C:\VisualStudio\PrivacyGuard\emails\dvdplanet.html"));
				else if (str.Equals("ebgames.com"))
					emails.Add(new Email(@"Fwd: Recommended XBOX games", @"C:\VisualStudio\PrivacyGuard\emails\ebgames.html"));
				else if (str.Equals("hsn.com"))
					emails.Add(new Email(@"Fwd: Fashion Watches at HSN", @"C:\VisualStudio\PrivacyGuard\emails\hsn.html"));
				else if (str.Equals("kbtoys.com"))
					emails.Add(new Email(@"Fwd: Recommended Baby Books at KBtoys", @"C:\VisualStudio\PrivacyGuard\emails\kbtoys.html"));
				else if (str.Equals("kmart.com"))
					emails.Add(new Email(@"Fwd: Featured MP3 Players at Kmart", @"C:\VisualStudio\PrivacyGuard\emails\kmart.html"));
				else if (str.Equals("macys.com"))
					emails.Add(new Email(@"Fwd: Macy*s's Recommended Men's Jeans", @"C:\VisualStudio\PrivacyGuard\emails\macys.html"));
				else if (str.Equals("pcconnection.com"))
					emails.Add(new Email(@"Fwd: Featured Scanners at PC Connection", @"C:\VisualStudio\PrivacyGuard\emails\pcconnection.html"));
				else if (str.Equals("radioshack.com"))
					emails.Add(new Email(@"Fwd: Featured Televisions at RadioShack", @"C:\VisualStudio\PrivacyGuard\emails\radioshack.html"));
				else if (str.Equals("staples.com"))
					emails.Add(new Email(@"Fwd: Weekly Deals at Staples", @"C:\VisualStudio\PrivacyGuard\emails\staples.html"));
				else if (str.Equals("target.com"))
					emails.Add(new Email(@"Fwd: Featured DVD Players at Target", @"C:\VisualStudio\PrivacyGuard\emails\target.html"));
				else if (str.Equals("travelocity.com"))
					emails.Add(new Email(@"Fwd: Travelocity FareWatcher Service", @"C:\VisualStudio\PrivacyGuard\emails\travelocity.html"));
				else if (str.Equals("yahoo.com"))
					emails.Add(new Email(@"Fwd: Recommended Digital Cameras at Yahoo! Shopping", @"C:\VisualStudio\PrivacyGuard\emails\yahoo.html"));
				str = sr.ReadLine();
			}
			sr.Close();
			DateTime yesterday = DateTime.Now.Subtract(new TimeSpan(1, 0, 0, 0, 0));
			dates.Add(yesterday.ToShortDateString() + " 8:34 AM");
			dates.Add(yesterday.ToShortDateString() + " 10:02 AM");
			dates.Add(yesterday.ToShortDateString() + " 10:11 AM");
			dates.Add(yesterday.ToShortDateString() + " 10:15 AM");
			dates.Add(yesterday.ToShortDateString() + " 10:22 AM");
			dates.Add(yesterday.ToShortDateString() + " 12:12 PM");
			dates.Add(yesterday.ToShortDateString() + " 12:15 PM");
			dates.Add(yesterday.ToShortDateString() + " 12:34 PM");
			dates.Add(yesterday.ToShortDateString() + " 12:47 PM");
			dates.Add(yesterday.ToShortDateString() + " 1:05 PM");
			dates.Add(yesterday.ToShortDateString() + " 1:06 PM");
			dates.Add(yesterday.ToShortDateString() + " 1:17 PM");
			dates.Add(yesterday.ToShortDateString() + " 1:29 PM");
			dates.Add(yesterday.ToShortDateString() + " 2:11 PM");
			dates.Add(yesterday.ToShortDateString() + " 2:15 PM");
			dates.Add(yesterday.ToShortDateString() + " 2:22 PM");
			dates.Add(yesterday.ToShortDateString() + " 3:29 PM");
			dates.Add(yesterday.ToShortDateString() + " 4:00 PM");
			dates.Add(yesterday.ToShortDateString() + " 6:57 PM");
			dates.Add(yesterday.ToShortDateString() + " 7:00 PM");

//			Random rng = new Random();
//			for (int i = emails.Count-1; i > 0; i--) 
//			{
//				int swap_i = rng.Next(i+1);
//				if (swap_i != i) 
//				{
//					Email tmp = (Email) emails[swap_i];
//					emails[swap_i] = emails[i];
//					emails[i] = tmp;
//				}
//			}
			for (int i = 0; i < emails.Count; i++) 
			{
				((Email)emails[i]).Date = (string)dates[i];
			}
		}
	}
}
