using System;
using System.Drawing;

namespace PrivacyGuard.WebWallet.InlineProtectionToolkit
{
	/// <summary>
	/// Summary description for Reminderbar.
	/// </summary>
	public class Reminderbar : System.Windows.Forms.Panel
	{
		public const int FIXEDY = 40;
		private int stepY = 4;

		private System.Windows.Forms.PictureBox reminderIcon;
		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\protect.png";
		public const int ICONW = 34;
		public const int ICONH = 34;
		public const int ICONX = 10;
		public const int ICONY = 3;

		public const string FONTNAME = "Microsoft Sans Serif";
		private Color fontcolor = Color.Black;
		private Color backcolor = Color.LightGreen;

		private System.Windows.Forms.Label reminder1;
		public const int R1X = 50;
		public const int R1Y = 3;
		public const int R1W = 165;
		public const int R1H = 20;
		public const int R1FONTSIZE = 10;
		public const string R1TEXT = "Web Wallet Protection:";

		private System.Windows.Forms.Label reminder2;
		public const int R2X = 215;
		public const int R2Y = 3;
		public const int R2W = 250;
		public const int R2H = 20;
		public const int R2FONTSIZE = 8;
		public const string R2TEXT = "(Press the F2 key to open the Web Wallet)";

		private System.Windows.Forms.Label reminder3;
		public const int R3X = 50;
		public const int R3Y = 21;
		public const int R3W = 810;
		public const int R3H = 17;
		public const int R3FONTSIZE = 10;
		public const string R3TEXT = "Login password is a piece of sensitive information. Always use the Web Wallet to submit it; Never provide it directly at the web site.";

		// animation
		private int hidePositionY;
		public int HidePositionY 
		{
			get 
			{
				return this.hidePositionY;
			}
		}
		private int showPositionY;
		public int ShowPositionY 
		{
			get 
			{
				return this.showPositionY;
			}
		}
		private bool showbar = false;
		public bool Showbar 
		{
			get 
			{
				return this.showbar;
			}
			set 
			{
				this.showbar = value;
			}
		}

		public Reminderbar(int pos)
		{
			//
			// TODO: Add constructor logic here
			//
			InitializeComponent();
			this.hidePositionY = pos - FIXEDY;
			this.showPositionY = pos;
		}
		private void InitializeComponent() 
		{
			this.Size = new Size(PrivacyGuard.IEBrowser.MAXIMIZEDX, FIXEDY);
			this.BackColor = backcolor;
			this.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;

			this.reminderIcon = new System.Windows.Forms.PictureBox();
			this.reminderIcon.Location = new Point(ICONX, ICONY);
			this.reminderIcon.Size = new Size(ICONW, ICONH);
			this.reminderIcon.Image = Image.FromFile(image_uri);

			this.reminder1 = new System.Windows.Forms.Label();
			this.reminder1.Location = new Point(R1X, R1Y);
			this.reminder1.Size = new Size(R1W, R1H);
			this.reminder1.Text = R1TEXT;
			this.reminder1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.reminder1.Font = new Font(FONTNAME, R1FONTSIZE, FontStyle.Bold);
			this.reminder1.ForeColor = fontcolor;

			this.reminder2 = new System.Windows.Forms.Label();
			this.reminder2.Location = new Point(R2X, R2Y);
			this.reminder2.Size = new Size(R2W, R2H);
			this.reminder2.Text = R2TEXT;
			this.reminder2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.reminder2.Font = new Font(FONTNAME, R2FONTSIZE);
			this.reminder2.ForeColor = fontcolor;

			this.reminder3 = new System.Windows.Forms.Label();
			this.reminder3.Location = new Point(R3X, R3Y);
			this.reminder3.Size = new Size(R3W, R3H);
			this.reminder3.Text = R3TEXT;
			this.reminder3.TextAlign = System.Drawing.ContentAlignment.TopLeft;
			this.reminder3.Font = new Font(FONTNAME, R3FONTSIZE);
			this.reminder3.ForeColor = fontcolor;

			this.Controls.Add(this.reminderIcon);
			this.Controls.Add(this.reminder1);
			this.Controls.Add(this.reminder2);
			this.Controls.Add(this.reminder3);
		}

		public void UpdateLocation ()
		{
			while (true)
			{
				System.Threading.Thread.Sleep(20);
				if (this.showbar) 
				{
					if (this.Location.Y != this.showPositionY)
						this.Location = new Point(this.Location.X, this.Location.Y+this.stepY);
					else 
						return;
				}
				else 
				{
					if (this.Location.Y != this.hidePositionY)
						this.Location = new Point(this.Location.X, this.Location.Y-this.stepY);
					else
						return;
				}
			}		
		}
		public bool NeedUpdate() 
		{
			if (this.showbar)
				return this.Location.Y != this.showPositionY;
			else
				return this.Location.Y != this.hidePositionY;
		}
	}
}
