using System;
using System.Collections;
using mshtml;

namespace PrivacyGuard.WebWallet.InlineProtectionToolkit.SensitiveData
{
	/// <summary>
	/// Summary description for LoginToken.
	/// </summary>
	public class LoginToken : SensitiveData
	{
		private string domain;
		public string Domain 
		{
//			get 
//			{
//				return this.domain;
//			}
			set 
			{
				this.domain = value;
			}
		}
		private IHTMLElement id;
		public IHTMLElement Id 
		{
			get 
			{
				return this.id;
			}
		}
		private ArrayList passwords;
		public ArrayList Passwords 
		{
			get 
			{
				return this.passwords;
			}
		}

		public class Password 
		{
			private IHTMLElement passwordValue;
			public IHTMLElement PasswordValue 
			{
				get 
				{
					return this.passwordValue;
				}
			}
			private string passwordScope = BackEndImpl.SecureStorage.DEFAULTSCOPE;
			public string PasswordScope 
			{
				get 
				{
					return this.passwordScope;
				}
			}

			public Password(IHTMLElement v) 
			{
				this.passwordValue = v;
			}
			public Password (IHTMLElement v, string s) : this (v) 
			{
				this.passwordScope = s;
			}
		}
		public LoginToken()
		{
			this.passwords = new ArrayList();
		}

		public void AddId (IHTMLElement id) 
		{
			this.id = id;
		}
		public void AddPassword(IHTMLElement pwd) 
		{
			this.passwords.Add(new Password(pwd));
		}
		public void AddPassword(IHTMLElement pwd, string s) 
		{
			this.passwords.Add(new Password(pwd, s));
		}
		public string GetAuthScope() 
		{
			string scope = BackEndImpl.SecureStorage.DEFAULTSCOPE;
			IEnumerator ienum = this.passwords.GetEnumerator();
			while (ienum.MoveNext()) 
			{
				Password pc = (Password) ienum.Current;
				scope = pc.PasswordScope;
				if (scope.Equals(BackEndImpl.SecureStorage.DEFAULTSCOPE))
					return BackEndImpl.SecureStorage.DEFAULTSCOPE;
			}
			return scope;
		}
	}
}
