using System;
using System.Collections;
using mshtml;

namespace PrivacyGuard.WebWallet.WebWalletToolkit.CardToolkit
{
	/// <summary>
	/// Summary description for CardtoPageBridge.
	/// </summary>
	public class CardPageBridge
	{
		private Hashtable cardtoPage;
		private Hashtable pagetoCard;

		private bool hasSubmit = false;
		public bool HasSubmit 
		{
			get 
			{
				return this.hasSubmit;
			}
		}

		public CardPageBridge()
		{
			this.cardtoPage = new Hashtable();
			this.pagetoCard = new Hashtable();
		}

		public void Reset() 
		{
			this.hasSubmit = false;
			this.cardtoPage = new Hashtable();
			this.pagetoCard = new Hashtable();
		}

		public void AddLink(System.Windows.Forms.Control c, IHTMLElement e) 
		{
//			if (!(e as IHTMLInputElement).readOnly)
//				c.TextChanged += new EventHandler(formControl_TextChanged);

			this.cardtoPage.Add(c, e);
			this.pagetoCard.Add(e, c);
		}

		public void Submit() 
		{
			this.hasSubmit = true;
			IDictionaryEnumerator ienum = this.cardtoPage.GetEnumerator();
			while (ienum.MoveNext()) 
			{
				System.Windows.Forms.Control c = (System.Windows.Forms.Control) ienum.Key;
				IHTMLElement e = (IHTMLElement) ienum.Value;

				(e as IHTMLInputElement).value = c.Text;
			}
		}

		public void ClearPage() 
		{
			this.hasSubmit = false;
			IDictionaryEnumerator ienum = this.cardtoPage.GetEnumerator();
			while (ienum.MoveNext()) 
			{
				IHTMLElement e = (IHTMLElement) ienum.Value;
				(e as IHTMLInputElement).value = "";
			}
		}
		
		private void formControl_TextChanged(object sender, System.EventArgs e) 
		{
			System.Windows.Forms.Control c = (System.Windows.Forms.Control)sender;
			IHTMLInputElement el = 
				(IHTMLInputElement) this.cardtoPage[c];
			el.value = c.Text;
		}
	}
}
