using System;
using System.Collections;
using System.Drawing;
using mshtml;

namespace PrivacyGuard.WebWallet.WebWalletToolkit.CardToolkit
{
	/// <summary>
	/// Summary description for StoredLoginCard.
	/// </summary>
	public class StoredLoginCard : Card
	{
		private BackEndImpl.SecureStorage.LoginToken storedToken;
		private string domainname;

		public StoredLoginCard(BackEndImpl.SecureStorage.LoginToken st, string d, 
			WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken t, 
			CardToolkit.CardPageBridge g, IEBrowser b) : base(t,g,b)
		{
			this.storedToken = st;
			this.domainname = d;
		}

		protected override string GetCardTitle() 
		{
			return "Login Card";
		}

		public override string GetCardDomain() 
		{
			return this.domainname;
		}

		protected override void FormValueArea() 
		{
			int x = 5;
			int y = 0;
			if (this.requestToken != null) 
			{
				IHTMLElement id = this.requestToken.Id;
				if (id != null) 
				{
					System.Windows.Forms.Label l = new System.Windows.Forms.Label();
					l.Location = new Point(x, y);
					l.Size = new Size(LABELW, ENTRYH);
					l.Text = "Login ID: username or email address";
					l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
					l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

					y += ENTRYH;

					System.Windows.Forms.Label t = new System.Windows.Forms.Label();
					t.Location = new Point(x, y);
					t.Size = new Size(LABELW, ENTRYH);
					t.Text = this.storedToken.Id;
					t.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				
					y += ENTRYH;

					this.valueArea.Controls.Add(l);
					this.valueArea.Controls.Add(t);

					y += INTERENTRYH;

					this.bridge.AddLink(t, id);
				}
				ArrayList a = this.requestToken.Passwords;
				ArrayList sa = this.storedToken.Passwords;
				IEnumerator aenum = a.GetEnumerator();
				IEnumerator saenum = sa.GetEnumerator();
				while (aenum.MoveNext() && saenum.MoveNext()) 
				{
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password p = 
						(WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password) aenum.Current;
					string pstr = (string) saenum.Current;

					System.Windows.Forms.Label l = new System.Windows.Forms.Label();
					l.Location = new Point(x, y);
					l.Size = new Size(LABELW, ENTRYH);
					l.Text = "Password:";
					l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
					l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

					y += ENTRYH;

					System.Windows.Forms.Label t = new System.Windows.Forms.Label();
					t.Location = new Point(x, y);
					t.Size = new Size(LABELW, ENTRYH);
					//t.Text = pstr;
					t.Text = new string('*', pstr.Length);
					t.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
					System.Windows.Forms.Label thide = new System.Windows.Forms.Label();
					thide.Location = new Point(x, y);
					thide.Size = new Size(LABELW, ENTRYH);
					thide.Text = pstr;
					thide.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				
					y += ENTRYH;

					this.valueArea.Controls.Add(l);
					this.valueArea.Controls.Add(t);
					this.valueArea.Controls.Add(thide);
					thide.Hide();

					y += INTERENTRYH;

					this.bridge.AddLink(thide, p.PasswordValue);
				}
			} 
			else 
			{
				System.Windows.Forms.Label l = new System.Windows.Forms.Label();
				l.Location = new Point(x, y);
				l.Size = new Size(LABELW, ENTRYH);
				l.Text = "Login ID: username or email address";
				l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
				l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

				y += ENTRYH;

				System.Windows.Forms.Label t = new System.Windows.Forms.Label();
				t.Location = new Point(x, y);
				t.Size = new Size(LABELW, ENTRYH);
				t.Text = this.storedToken.Id;
				t.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				this.parent.DndDirection.UpdateIdValue(t.Text);

				y += ENTRYH;

				this.valueArea.Controls.Add(l);
				this.valueArea.Controls.Add(t);

				y += INTERENTRYH;

				l = new System.Windows.Forms.Label();
				l.Location = new Point(x, y);
				l.Size = new Size(LABELW, ENTRYH);
				l.Text = "Password:";
				l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
				l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

				y += ENTRYH;

				ArrayList sa = this.storedToken.Passwords;
				string pstr = (string) sa[0];

				t = new System.Windows.Forms.Label();
				t.Location = new Point(x, y);
				t.Size = new Size(LABELW, ENTRYH);
				//t.Text = pstr;
				t.Text = new string('*', pstr.Length);
				t.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				System.Windows.Forms.Label thide = new System.Windows.Forms.Label();
				thide.Location = new Point(x, y);
				thide.Size = new Size(LABELW, ENTRYH);
				thide.Text = pstr;
				thide.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				this.parent.DndDirection.UpdatePasswordValue(thide.Text);

				y += ENTRYH;

				this.valueArea.Controls.Add(l);
				this.valueArea.Controls.Add(t);
				this.valueArea.Controls.Add(thide);
				thide.Hide();

				y += INTERENTRYH;
			}

//			if (this.authscope == null)
//				this.valueArea.Location = new Point(0, 55);
//			else
//				this.valueArea.Location = new Point(0, 75);
		}
	}
}
