using System;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for ChoosingInterface.
	/// </summary>
	public class ChoosingInterface : System.Windows.Forms.Panel
	{
		private System.Windows.Forms.Label promptLabel;
//		private System.Windows.Forms.Panel recipientTable;
//		private System.Windows.Forms.Label domainColumn;
//		private System.Windows.Forms.Label domainColumn2;
//		private System.Windows.Forms.Label ratingColumn;
//		private System.Windows.Forms.LinkLabel switchLabel;
//		private System.Windows.Forms.Label warning;

		private RecipientArea recipientArea;

//		private int tableHeight;
//		private int areaHeight;

		private DataInputInterface inputInterface;
		public DataInputInterface InputInterface 
		{
			get 
			{
				return this.inputInterface;
			}
		}

		public ChoosingInterface(DataInputInterface p)
		{
			this.inputInterface = p;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Location = new Point(0, 0);
			this.Size = new Size(DataInputInterface.SECONDW, DataInputInterface.SECONDH);

//			this.tableHeight = this.Height-75;
//			this.areaHeight = this.tableHeight-30;

			this.promptLabel = new System.Windows.Forms.Label();
//			this.recipientTable = new System.Windows.Forms.Panel();
//			this.domainColumn = new System.Windows.Forms.Label();
//			this.domainColumn2 = new System.Windows.Forms.Label();
//			this.ratingColumn = new System.Windows.Forms.Label();
//			this.switchLabel = new System.Windows.Forms.LinkLabel();
//			this.switchLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(switchLabel_LinkClicked);
//			this.warning = new System.Windows.Forms.Label();

			this.recipientArea = new RecipientArea(this.inputInterface.ParentInterface.Browser);

			this.promptLabel.Font = 
				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
				this.promptLabel.Font.Size);
			this.promptLabel.Location = new System.Drawing.Point(0, 0);
//			this.promptLabel.Size = new System.Drawing.Size(this.Width, 75);
			this.promptLabel.Size = new System.Drawing.Size(this.Width, 30);
//			this.promptLabel.Text = "Please make sure that the password will be filled in to the correct website: (the following list is generated from your browsing history)";
			this.promptLabel.Text = "Please make sure that the password will be filled in to the correct website:";
//			this.promptLabel.Text = "You never use the Web Wallet to submit this password to " + this.inputInterface.Browser.GetDomainName(false) + ". " +
//				"Does this site claim to be any of the following sites that you have had account with?";

//			this.recipientTable.Location = new System.Drawing.Point(0, 75);
//			this.recipientTable.Size = new Size(this.Width, this.tableHeight);
//			this.recipientTable.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
//
//			this.domainColumn.Font = 
//				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
//				this.domainColumn.Font.Size, System.Drawing.FontStyle.Bold);
//			this.domainColumn.Location = new System.Drawing.Point(15, 0);
//			this.domainColumn.Size = new System.Drawing.Size(100, 15);
//			this.domainColumn.Text = "Web Site";
//			this.domainColumn.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
//			this.domainColumn2.Font = 
//				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
//				this.domainColumn.Font.Size);
//			this.domainColumn2.Location = new System.Drawing.Point(15, 15);
//			this.domainColumn2.Size = new System.Drawing.Size(150, 15);
//			this.domainColumn2.Text = "(in alphabetic order)";
//			this.domainColumn2.TextAlign = System.Drawing.ContentAlignment.TopLeft;
//
//			this.ratingColumn.Font = 
//				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
//				this.ratingColumn.Font.Size, System.Drawing.FontStyle.Bold);
//			this.ratingColumn.Location = new System.Drawing.Point(148, 0);
//			this.ratingColumn.Size = new System.Drawing.Size(80, 15);
//			this.ratingColumn.Text = "Trust Rating";
//			this.ratingColumn.TextAlign = System.Drawing.ContentAlignment.BottomRight;

			this.recipientArea.Location = new Point(0, 30);
//			this.recipientArea.Size = new Size(this.Width, this.areaHeight);
			this.recipientArea.Size = new Size(this.Width, this.Height-30);

//			this.recipientTable.Controls.Add(this.domainColumn);
//			this.recipientTable.Controls.Add(this.domainColumn2);
//			this.recipientTable.Controls.Add(this.ratingColumn);
//			this.recipientTable.Controls.Add(this.recipientArea);

//			this.Controls.Add(this.switchLabel);
//			this.Controls.Add(this.warning);
			this.Controls.Add(this.promptLabel);
//			this.Controls.Add(this.recipientTable);
			this.Controls.Add(this.recipientArea);
		}

//		private void switchLabel_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
//		{
//			System.Windows.Forms.LinkLabel ll = (System.Windows.Forms.LinkLabel) sender;
//			string text = ll.Text;
//			if (text.Equals("More sites")) 
//				this.UpdateDisplay(false);
//			else
//				this.UpdateDisplay(true);
//		}

		public void UpdateDisplay(bool trusted) 
		{
//			this.promptLabel.Text = "You have never used the Web Wallet to submit this password to " + this.inputInterface.Browser.GetDomainName(false) + ". " +
//				"Does this site claim to be any of the following sites that you have had an account with?";

			this.recipientArea.UpdateDisplay();
//			if (trusted) 
//			{
//				this.recipientTable.Size = new Size(this.recipientTable.Width, this.tableHeight-15);
//				this.recipientArea.Size = new Size(this.recipientArea.Width, this.areaHeight-15);
//				this.recipientArea.UpdateDisplay(trusted);
//				this.switchLabel.Text = "More sites";
//				this.switchLabel.Location = new Point(this.recipientTable.Right-100, this.recipientTable.Bottom);
//				this.switchLabel.Size = new Size(100, 15);
//				this.switchLabel.TextAlign = System.Drawing.ContentAlignment.BottomRight;
//				this.warning.Hide();
//				(this.Parent.Parent as DataInputInterface).EnableOKButton(false);
//			} 
//			else 
//			{
//				this.recipientTable.Size = new Size(this.recipientTable.Width, this.tableHeight-150);
//				this.recipientArea.Size = new Size(this.recipientArea.Width, this.areaHeight-150);
//				this.recipientArea.UpdateDisplay(trusted);
//				this.switchLabel.Text = "See the trusted sites";
//				this.switchLabel.Location = new Point(this.recipientTable.Right-150, this.recipientTable.Bottom+135);
//				this.switchLabel.Size = new Size(150, 15);
//				this.warning.Show();
//				this.warning.Location = new Point(this.recipientTable.Left, this.recipientTable.Bottom);
//				this.warning.Size = new Size(this.recipientTable.Width, 135);
//				this.warning.Text = "The sites in this list are untrusted. Please look at the site report by clicking the description link under the site name. Make sure that it is EXACTLY the site that you want to send the password to." +
//					" Send the password to a wrong site may make your account accessible by other people and result in unwanted disclosure of your personal information."; 
//				this.warning.ForeColor = Color.Red;
//				this.warning.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.warning.Font.Size, FontStyle.Bold);
//				(this.Parent.Parent as DataInputInterface).EnableOKButton(false);
//			}
		}

//		public bool ReadySubmit() 
//		{
//			if (!this.recipientArea.Selected.Domainname.Equals(this.recipientArea.Current.Domainname)) 
//			{
//				this.inputInterface.ShowSecondaryInterface(DataInputInterface.SECONDDISPLAY.CONFIRMING, true);
//				return false;
//			}
//			return true;
//		}

		public bool SelectionMatch() 
		{
			return this.recipientArea.Selected.Domainname.Equals(
				this.recipientArea.Current.Domainname);
		}

		public bool SelectionTrusted() 
		{
			return this.recipientArea.Selected.IsTrusted();
		}

		public RecipientArea.RecipientEntry GetSelectedEntry() 
		{
			return this.recipientArea.Selected;
		}
		public RecipientArea.RecipientEntry GetActualEntry() 
		{
			return this.recipientArea.Current;
		}
	}
}
