using System;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for ConfirmingInterface2.
	/// </summary>
	public class ConfirmingInterface2 : System.Windows.Forms.Panel
	{
		System.Windows.Forms.Label prompt;
		WebWallet.SiteReportBox.SiteDescription desp;
//		System.Windows.Forms.LinkLabel fillin;
		System.Windows.Forms.Label searchPrompt;
		System.Windows.Forms.TextBox searchText;
		System.Windows.Forms.Button searchButton;

		DataInputInterface inputInterface;
		public ConfirmingInterface2(DataInputInterface d)
		{
			this.inputInterface = d;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Location = new Point(0, 0);
			this.Size = new Size(DataInputInterface.SECONDW, DataInputInterface.SECONDH);

			this.prompt= new System.Windows.Forms.Label();
			this.prompt.Text = "Here is this site's description:";
			this.prompt.Location = new System.Drawing.Point(0, 0);
			this.prompt.Size = new System.Drawing.Size(this.Width, 15);
			this.prompt.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

			string domain = this.inputInterface.Browser.GetDomainName(false);
            this.desp = new PrivacyGuard.WebWallet.SiteReportBox.SiteDescription(
				domain, this.inputInterface.Browser.ReputationEvaluator.GetReputationRecord(domain));
			this.desp.Location = new Point(0,20);
			this.desp.Shrink(this.Width);
			this.desp.BackColor = Color.White;
			this.desp.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;

//			this.fillin = new System.Windows.Forms.LinkLabel();
//			this.fillin.Text = "Fill in the new card";
//			this.fillin.Location = new Point(0, this.desp.Top+this.desp.Height+5);
//			this.fillin.Size = new Size(this.Width, 15);
//			this.fillin.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(fillin_LinkClicked);

			this.searchPrompt = new System.Windows.Forms.Label();
			this.searchPrompt.Text = "If it is not your intended site, search your intended site using Google.";
			this.searchPrompt.Location = new Point(0, this.desp.Bottom+15);
			this.searchPrompt.Size = new Size(this.Width, 45);
			this.searchPrompt.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

			this.searchText = new System.Windows.Forms.TextBox();
			this.searchText.Location = new Point(5, searchPrompt.Bottom);
			this.searchText.Size = new Size(this.Width-10, 15);

			this.searchButton = new System.Windows.Forms.Button();
			this.searchButton.Size = new Size(100, 20);
			this.searchButton.Location = new Point(5, this.searchText.Bottom+5);
			this.searchButton.Text = "Google Search";
			this.searchButton.Click += new EventHandler(searchButton_Click);

			this.Controls.Add(this.prompt);
			this.Controls.Add(this.desp);
//			this.Controls.Add(this.fillin);
			this.Controls.Add(this.searchPrompt);
			this.Controls.Add(this.searchText);
			this.Controls.Add(this.searchButton);
		}

		public void UpdateDisplay() 
		{
			this.Controls.Remove(this.desp);
			this.desp = null;
			string domain = this.inputInterface.Browser.GetDomainName(false);
			this.desp = new PrivacyGuard.WebWallet.SiteReportBox.SiteDescription(
				domain, this.inputInterface.Browser.ReputationEvaluator.GetReputationRecord(domain));
			this.desp.Location = new Point(0,20);
			this.desp.Shrink(this.Width);
			this.desp.BackColor = Color.White;
			this.desp.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Controls.Add(this.desp);
//			this.fillin.Location = new Point(0, this.desp.Top+this.desp.Height+5);
			this.searchPrompt.Location = new Point(0, this.desp.Bottom+15);
			this.searchText.Location = new Point(5, searchPrompt.Bottom);
			this.searchButton.Location = new Point(5, this.searchText.Bottom+5);
		}

//		private void fillin_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
//		{
//			this.inputInterface.FillinNewCard();
//		}

		private void searchButton_Click(object sender, System.EventArgs e) 
		{
			this.inputInterface.Browser.GotoGooglesearch(this.searchText.Text);
			string domainname = this.inputInterface.Browser.GetDomainName(true);
			PhishingAttacks.PhishingConfig.ATTACKTYPE at = 
				this.inputInterface.Browser.Phishingmonitor.GetPhishingType(domainname);
			if (at != PhishingAttacks.PhishingConfig.ATTACKTYPE.NONE)
				this.inputInterface.Browser.Phishingmonitor.RemoveAttack(domainname);
		}
	}
}
