using System;
using System.Windows.Forms;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for DnDDirectionInterface.
	/// </summary>
	public class DnDDirectionInterface : System.Windows.Forms.Panel
	{
		public const int DIRECTIONH = 60;
		public const int DATAX = 0;
		public const int DATAY = 70;
		public const int DATAH = 120;

		public const int LABELH = 15;
		public const int VALUEH = 30;

		private System.Windows.Forms.Label direction;
		private System.Windows.Forms.Panel dataDisplay;
		private System.Windows.Forms.Label idLabel;
		private System.Windows.Forms.TextBox idValue;
		private System.Windows.Forms.Panel idValueP;
		private System.Windows.Forms.Label pwdLabel;
		private System.Windows.Forms.TextBox pwdValue;
		private System.Windows.Forms.Panel pwdValueP;
		private System.Windows.Forms.PictureBox idIcon;
		private System.Windows.Forms.PictureBox pwdIcon;

		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\dragdrop.gif";

		public DnDDirectionInterface()
		{
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Location = new Point(0,0);
			this.Size = new Size(DataInputInterface.SECONDW, DataInputInterface.SECONDH);

			this.direction = new Label();
			this.direction.Location = new Point(0, 0);
			this.direction.Size = new Size(this.Width, DIRECTIONH);
			this.direction.Text = "Please drag and drop each text field to the input box in the web page so that the Web Wallet can recoginze this page next time.";
			this.direction.Font = new Font(WebWalletInterface.FONTNAME, this.direction.Font.Size);
			this.Controls.Add(this.direction);

			this.dataDisplay = new Panel();
			this.dataDisplay.Location = new Point(DATAX, DATAY);
			this.dataDisplay.Size = new Size(this.Width, DATAH);
			this.Controls.Add(this.dataDisplay);

			this.idLabel = new Label();
			this.idLabel.Location = new Point(5, 5);
			this.idLabel.Size = new Size(this.dataDisplay.Width-10, LABELH);
			this.idLabel.Text = "Login ID: username or email address";
			this.idLabel.Font = new Font(WebWalletInterface.FONTNAME, this.idLabel.Font.Size, FontStyle.Bold);
			this.idLabel.TextAlign = ContentAlignment.MiddleLeft;
			this.dataDisplay.Controls.Add(this.idLabel);

			this.idValueP = new Panel();
			this.idValueP.Location = new Point(5, 25);
			this.idValueP.Size = new Size(this.dataDisplay.Width-10, VALUEH);
			this.idValueP.BackColor = Color.White;
			this.dataDisplay.Controls.Add(this.idValueP);
			this.idIcon = new PictureBox();
			this.idIcon.Location = new Point(0, 2);
			this.idIcon.Size = new Size(18, 26);
			this.idIcon.Image = Image.FromFile(this.image_uri);
			this.idValueP.Controls.Add(this.idIcon);
			this.idValue = new TextBox();
			this.idValue.Location = new Point(20, 0);
			this.idValue.Size = new Size(this.idValueP.Width-20, VALUEH);
			this.idValue.Font = new Font(WebWalletInterface.FONTNAME, this.idValue.Font.Size);
			//this.idValue.TextAlign = ContentAlignment.MiddleLeft;
			this.idValue.ReadOnly = true;
			this.idValue.BackColor= Color.White;
			this.idValue.Cursor = Cursors.Hand;
			this.idValue.BorderStyle = BorderStyle.None;
			this.idValue.MouseDown += new System.Windows.Forms.MouseEventHandler(Data_MouseDown);
//			this.idValue.MouseMove += new MouseEventHandler(Data_MouseMove);
			this.idValueP.Controls.Add(this.idValue);

			this.pwdLabel = new Label();
			this.pwdLabel.Location = new Point(5, 65);
			this.pwdLabel.Size = new Size(this.dataDisplay.Width-10, LABELH);
			this.pwdLabel.Text = "Password";
			this.pwdLabel.Font = new Font(WebWalletInterface.FONTNAME, this.pwdLabel.Font.Size, FontStyle.Bold);
			this.pwdLabel.TextAlign = ContentAlignment.MiddleLeft;
			this.dataDisplay.Controls.Add(this.pwdLabel);

			this.pwdValueP = new Panel();
			this.pwdValueP.Location = new Point(5, 85);
			this.pwdValueP.Size = new Size(this.dataDisplay.Width-10, VALUEH);
			this.pwdValueP.BackColor = Color.White;
			this.dataDisplay.Controls.Add(this.pwdValueP);
			this.pwdIcon = new PictureBox();
			this.pwdIcon.Location = new Point(0, 2);
			this.pwdIcon.Size = new Size(18, 26);
			this.pwdIcon.Image = Image.FromFile(this.image_uri);
			this.pwdValueP.Controls.Add(this.pwdIcon);
			this.pwdValue = new TextBox();
			this.pwdValue.Location = new Point(20, 0);
			this.pwdValue.Size = new Size(this.pwdValueP.Width-20, VALUEH);
			this.pwdValue.Font = new Font(WebWalletInterface.FONTNAME, this.pwdValue.Font.Size);
			//this.pwdValue.TextAlign = ContentAlignment.MiddleLeft;
			this.pwdValue.ReadOnly = true;
			this.pwdValue.PasswordChar = '*';
			this.pwdValue.BackColor = Color.White;
			this.pwdValue.BorderStyle = BorderStyle.None;
			this.pwdValue.Cursor = Cursors.Hand;
			this.pwdValue.MouseDown += new System.Windows.Forms.MouseEventHandler(Data_MouseDown);
//			this.pwdValue.MouseMove += new MouseEventHandler(Data_MouseMove);
			this.pwdValueP.Controls.Add(this.pwdValue);
		}

		public void Data_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) 
		{
			System.Windows.Forms.Control c = (System.Windows.Forms.Control) sender;
			c.DoDragDrop(c.Text, DragDropEffects.Copy | DragDropEffects.Move);
		}
//		public void Data_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e) 
//		{
//			this.Cursor = Cursors.Hand;
//		}

		public void UpdateIdValue(string s) 
		{
			this.idValue.Text = s;
		}
		public void UpdatePasswordValue(string s) 
		{
			this.pwdValue.Text = s;
		}
	}
}
