using System;
using System.Windows.Forms;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for ErrorInterface.
	/// </summary>
	public class ErrorInterface : System.Windows.Forms.Panel
	{
		//private ConfirmingInterface confirmingInterface;
		//private NoaffordanceInterface noaffordanceInterface;
		private WebWalletInterface webwallet;

		System.Windows.Forms.Label domain;
		DomainDescription description;
		System.Windows.Forms.PictureBox rating;
		System.Windows.Forms.Label reminder;
		System.Windows.Forms.Label prompt;

		public ErrorInterface(WebWalletInterface p)
		{
			this.webwallet = p;
			//this.confirmingInterface = new ConfirmingInterface(this.parentInterface);
			//this.noaffordanceInterface = new NoaffordanceInterface(this.parentInterface);
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
//			this.confirmingInterface.Location = new Point(0, 0);
//			this.confirmingInterface.Size = this.Size;
//			this.Controls.Add(this.confirmingInterface);

			this.Location = new Point(WebWalletInterface.INPUTFACEX, WebWalletInterface.INPUTFACEY);
			this.Size = new Size(WebWalletInterface.INPUTFACEW, WebWalletInterface.INPUTFACERH);

//			this.noaffordanceInterface.Location = new Point(0,0);
//			this.noaffordanceInterface.Size = this.Size;
//			this.Controls.Add(this.noaffordanceInterface);
			//this.noaffordanceInterface.Hide();

			this.domain = new System.Windows.Forms.Label();
			this.domain.Location = new Point(0, 0);
			this.domain.Size = new Size(this.Width, 20);
			this.domain.Font = new Font(WebWalletInterface.FONTNAME, 10, FontStyle.Bold);
			this.domain.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;

			this.description = new DomainDescription();
			this.description.Location = new Point(0, 25);
			this.description.Size = new Size(this.Width, 15);
			this.description.Font = new Font(WebWalletInterface.FONTNAME, this.description.Font.Size);
			this.description.TextAlign = ContentAlignment.MiddleCenter;
			this.description.LinkClicked += new LinkLabelLinkClickedEventHandler(description_LinkClicked);

			this.rating = new PictureBox();
			this.rating.Location = new Point((int)((this.Width-64)/2), 45);
			this.rating.Size = new Size(64, 12);

			this.reminder = new Label();
			this.reminder.Location = new Point(0, 65);
			this.reminder.Size = new Size(this.Width, 30);
			this.reminder.Text = @"Always use the Web Wallet to submit your sensitive information with this site.";

			this.prompt = new Label();
			this.prompt.Location = new Point(0, 100);
			this.prompt.Size = new Size(this.Width, 30);
			this.prompt.Text = "Choose the sensitive information that you want to submit from the card folders below.";
			this.prompt.Font = new Font(WebWalletInterface.FONTNAME, this.prompt.Font.Size);
			this.prompt.TextAlign = ContentAlignment.MiddleLeft;

			this.Controls.Add(this.domain);
			this.Controls.Add(this.description);
			this.Controls.Add(this.rating);
			this.Controls.Add(this.prompt);
			this.Controls.Add(this.reminder);
		}

		private void description_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.webwallet.ShowSiteReport(sender as DomainDescription);
//			LinkLabel ll = (LinkLabel)sender;
//			Rectangle llrect = ll.RectangleToScreen(ll.ClientRectangle);
//			Point tr = new Point(llrect.Left,llrect.Top);
//			WebWallet.SiteReportBox sitereport = new SiteReportBox(this.webwallet.Browser, this.domain.Text, tr);
//			sitereport.Show();
		}

		public void UpdateDisplay() 
		{
			string domainstr = this.webwallet.Browser.GetDomainName(false);
			BackEndImpl.ReputationEvaluator.ReputationRecord rr = 
				this.webwallet.Browser.ReputationEvaluator.GetReputationRecord(domainstr);

			this.domain.Text = rr.Domain;
			this.description.Domain = rr.Domain;
			this.description.Text = rr.Description;
			this.rating.Image = Image.FromFile(rr.GetRatingImage());

			if (!rr.IsTrustedSite()) 
			{
				this.description.LinkColor = Color.Red;
				this.description.Font = new Font(WebWalletInterface.FONTNAME, this.description.Font.Size, FontStyle.Bold);
			} 
			else 
			{
				this.description.LinkColor = Color.Blue;
				this.description.Font = new Font(WebWalletInterface.FONTNAME, this.description.Font.Size);
			}
		}
	}
}
