#import "Controller.h"
#import "OKButton.h"
#import <unistd.h>

@implementation Controller

-(void)save:sender
{
    NSRange allRange;
    allRange.location = 0;
    allRange.length = [[text textStorage]  length];
    [[text RTFFromRange:allRange] writeToFile:transcriptFileName atomically:YES];
}

-(void)append:(NSString *)str
{
    NSRange endRange;

    endRange.location = [[text textStorage] length];
    endRange.length = 0;
    
    [text replaceCharactersInRange:endRange withString:str];
    endRange.location = [[text textStorage] length];
    [text setSelectedRange:endRange];
    [text scrollRangeToVisible:endRange];
    [self save:nil];
}

-(void)appendAttributedString:(NSAttributedString *)astr
{
    NSTextStorage *ts = [text textStorage];
    NSRange endRange;

    [ts appendAttributedString:astr];
    endRange.location = [ts length];
    endRange.length = 0;
    
    [text setSelectedRange:endRange];
    [text scrollRangeToVisible:endRange];
    [self save:nil];
}

-(void)timestampWithString:(NSString *)s2
{
    time_t t=time(0);
    char *buf = ctime(&t);
    char *cc;

    NSString *str;
    NSMutableAttributedString *astr;

    /* Erase the \n at the end of buf */
    cc = index(buf,'\n');
    if(cc) *cc = '\000';

    str = [NSString stringWithFormat:@"\n%s %@\n",buf,s2];
    astr = [[NSMutableAttributedString alloc]
					  initWithString:str
					  attributes:
					      [NSDictionary dictionaryWithObject:[NSColor darkGrayColor]
							    forKey:NSForegroundColorAttributeName]];

    [astr setAttributes:[NSDictionary dictionaryWithObject:[NSColor blackColor]
				      forKey:NSForegroundColorAttributeName]
	  range:NSMakeRange([str length]-1,1)];

    [self appendAttributedString:astr];
}

-(void)sendEmail:(NSString *)str_
{
    NSMutableString *str = [NSMutableString stringWithFormat:@"~/mit/johnny2/sendmessage %@",str_];
    if([signSwitch intValue]){
	[str appendString:@" -z"];
    }
    str = [[str stringByExpandingTildeInPath] mutableCopy];
    
    chdir("/Users/simsong/mit/johnny2/");

    [self append:@"% "];
    [self append:str];
    [self append:@"\n"];
    system([str cString]);
}

-(void)tick:sender
{
    [self timestampWithString:@""];
}

-(void)okay:sender
{
    NSEnumerator *en = [[[window contentView] subviews] objectEnumerator];
    NSTextField *tf     = [(OKButton *)sender text];
    int tag             = [(OKButton *)sender tag];

    NSMutableAttributedString *astr;
    NSString *s2 = [tf stringValue];
    NSRange r1;
    
    if(timer==nil){
	timer = [NSTimer scheduledTimerWithTimeInterval:60.0
			 target:self
			 selector:@selector(tick:)
			 userInfo:nil repeats:YES];
    }

    [self append:@"\n"];
    [self timestampWithString:s2];

    // Now make the text field lightGray
    astr = [[tf attributedStringValue] mutableCopy];
    [astr setAttributes:[NSDictionary dictionaryWithObject:[NSColor lightGrayColor]
				     forKey:NSForegroundColorAttributeName] 
	 range:NSMakeRange(0,[astr length])];
    [tf setAttributedStringValue:astr];
    
    /* See if there is a message to send */
    r1 = [s2 rangeOfString:@"Send"];
    if(r1.location!=NSNotFound){
	NSRange r2 = [s2 rangeOfString:@"email #"];
	NSMutableString *msg = [[s2 substringFromIndex:r2.location+r2.length] mutableCopy];
	[self sendEmail:msg];
    }
	
    [[(OKButton *)sender completed] setState:YES];
    [[(OKButton *)sender next] setEnabled:YES];
    [sender setEnabled:FALSE];
    [self append:@"\n"];
    
    if(tag==666){
	[self append:[NSString stringWithContentsOfFile:@"evaluation.txt"]];
    }
}


-(void)awakeFromNib
{
	NSButton *v;
	int i;

	/* Find a filename for the transcript */
	i = 0;
	do {
	    transcriptFileName = [NSString stringWithFormat:@"~/mit/johnny2/trans/transcript.%d.rtf",++i];
	    transcriptFileName = [transcriptFileName stringByExpandingTildeInPath];
	} while(access([transcriptFileName cString],R_OK)==0);
	[transcriptFileName retain];         // this one is a keeper
	[runField setIntValue:i];
	
	if(i==35 || i==37 || i==38 || i==40 || i==43){
	    [self append:@"Running with signing turned OFF!\n\n"];
	    [signSwitch setIntValue:1];
	}
	else{
	    [self append:@"Running with signing turned ON!\n\n"];
	    [signSwitch setIntValue:0];
	}
}

- (void)textDidChange:(NSNotification *)aNotification
{
    [self save:nil];
}
@end
